//
// $Id: dataram.h,v 1.10 2003/10/08 20:39:35 nj Exp $
//
#ifndef _DATARAM_H
#define _DATARAM_H
#include <systemc.h>
#include "config.h"

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


SC_MODULE(dataram)
{
  sc_in<bool> clk;

  sc_in<sc_uint<16> > ramadr;
  sc_in<sc_logic> ramre;
  sc_in<sc_logic> ramwe;
  sc_in<sc_lv<8> > dbusin;
  sc_out<sc_lv<8> > dbusout;

  sc_lv<8> ramfile[RAMMEMSIZE];
#ifdef DEBUG_MEMCONTENTS
  int memcontents;
#endif

  int fd;

  void datawrite();
  void dataread();

  typedef dataram SC_CURRENT_USER_MODULE;
  dataram(sc_module_name name, char *contents_file)
  {
      unsigned int i = 0;
      unsigned long line;
      unsigned int codepos = 0;

      unsigned char *buf;
      unsigned char *code;

#ifdef DEBUG_MEMCONTENTS
      unsigned int ci = 0x00000000;

      // Create blank memory file filled with 0's
      memcontents = open("mem.bin", O_CREAT | O_RDWR, 0666);
      for (i = 0; i < (RAMMEMSIZE/4); i++)
	write(memcontents, &ci, 4);
      close(memcontents);
#endif

      FILE *fid = fopen(contents_file, "r");
      buf = (unsigned char*)malloc(32768);
      int size = fread(buf, 1, 32768, fid);
      code = (unsigned char*)malloc(RAMMEMSIZE);

      memcpy(code,buf,size);
      codepos = size;

      i = 0;
      while (i < codepos)
	{
	  line = code[i];

#ifdef DEBUG_MEMORY
	  printf("%04d : 0x%02X\n", i, line);
#endif
	  ramfile[i] = (sc_lv<16>)line;
	  i++;
	}

    SC_METHOD(datawrite);
    sensitive_neg << clk;

    SC_METHOD(dataread);
    sensitive_neg << clk;
  }  
};

#endif
