//
// $Id: instmemory.h,v 1.5 2003/10/06 19:39:00 nj Exp $
//
#ifndef _INSTMEMORY_H
#define _INSTMEMORY_H

#include <systemc.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "config.h"

SC_MODULE(instmemory)
{
  sc_in<bool> clk;
  sc_in<bool> reset;

  sc_in<sc_uint<16> > pc;
  sc_out<sc_lv<16> > inst;

  sc_lv<16> x[INSTMEMSIZE];

  char *memoryname;
  // unsigned int pc;

  void mread();

#ifdef _CC_MEMDUMP_
  int memcontents;
#endif

  typedef instmemory SC_CURRENT_USER_MODULE;
  instmemory(sc_module_name name, char *contents_file)
    {
      unsigned int i = 0;
      unsigned long line;
      unsigned int codepos = 0;

      unsigned char *buf;
      unsigned char *code;

#ifdef _CC_MEMDUMP_
      unsigned int ci = 0x00000000;

      // Create blank memory file filled with 0's
      memcontents = open("mem.bin", O_CREAT | O_RDWR, 0666);
      for (i = 0; i < (INSTMEMSIZE/4); i++)
	write(memcontents, &ci, 4);
      close(memcontents);
#endif

      FILE *fid = fopen(contents_file, "r");
      buf = (unsigned char*)malloc(32768);
      int size = fread(buf, 1, 32768, fid);
      code = (unsigned char*)malloc(INSTMEMSIZE);

      memcpy(code,buf,size);
      codepos = size;

      i = 0;
      while (i < codepos)
	{
	  line  = code[i];
	  line += (code[i+1]<<8);

#ifdef DEBUG_MEMORY
	  printf("%04d : 0x%04X\n", i/2, line);
	  //fprintf(stdout, "%d : %X\n", i>>2, line);
#endif
	  x[i/2] = (sc_lv<16>)line;
	  i += 2;
	}

      SC_METHOD(mread);
      sensitive_neg << clk;
    }
};

#endif
