//
//$Id: pm_fetch_dec.cc,v 1.34 2003/10/08 20:39:35 nj Exp $
//
#include "pm_fetch_dec.h"
#include "stdio.h"

//
// Fetch instruction
//
// sensitive_pos << clk
void pm_fetch_dec::instruction_fetch()
{
  sc_lv<16> v_instruction_reg;
  sc_lv<8> v_sreg_bop_wr_en = sreg_bop_wr_en;
  sc_logic v_sreg_adr_eq = sreg_adr_eq;
  sc_lv<8> v_dbusout_int = dbusout_int;

  if (!nrst)
    {
      v_instruction_reg = "0000000000000000";
    }
  else
    {
      // Comment in for test!
      // if (instruction_reg_ena.read() == 1)

      // if (override_inst.read() == SC_LOGIC_0)
      v_instruction_reg = inst;
      // else
      // v_instruction_reg = "0000000000000000";
    }

  /*
  cout << "pm_fetch_dec::instruction_fetch()" << endl;
  cout << "fetch instruction " << v_instruction_reg << endl;
  */
  instruction_reg = v_instruction_reg;
}

void pm_fetch_dec::latcht_rd_adr()
{
  if (!nrst)
    {
      dex_adrreg_d_latched = "00000";
    }
  else
    {
      if ((idc_ld_x.read() | idc_ld_y.read() | idc_ldd_y.read() | idc_ld_z.read() |
	   idc_ldd_z.read() | idc_sts.read() | idc_st_x.read() | idc_st_y.read() |
	   idc_std_y.read() | idc_st_z.read() | idc_std_z.read() | idc_lds.read() |
	   idc_pop.read()) == 1)
      {
        dex_adrreg_d_latched = dex_adrreg_d.read();
      }
    }
}

void pm_fetch_dec::adiw_sbiw_high_reg_adr()
{
  sc_lv<5> tmp = adiw_sbiw_encoder_out.read();
  sc_uint<5> i_tmp = tmp;
  sc_lv<5> v_adiw_sbiw_encoder_mux_out = adiw_sbiw_encoder_mux_out.read();

  if (!nrst)
    {
      v_adiw_sbiw_encoder_mux_out = "00000";
    }
  else
    {
      v_adiw_sbiw_encoder_mux_out = i_tmp + 1;
    }

  adiw_sbiw_encoder_mux_out = v_adiw_sbiw_encoder_mux_out;
}

//
//
//
// sensitive_pos << clk
void pm_fetch_dec::ramadr_reg()
{
  sc_lv<16> v_ramadr = ramadr_int.read();
  // sc_uint<16> i_ramadr = v_ramadr;

  if (!nrst)
    {
      v_ramadr   = "0000000000000000";
    }
  else
    {
      if (ramadr_reg_en.read() == 1)
	v_ramadr = ramadr_reg_in.read();
    }

  ramadr     = (sc_lv<16>)v_ramadr;
  ramadr_int = v_ramadr;

  /*
  cout << "pm_fetch_dec::ramadr_reg()" << endl;
  cout << "ramadr_reg_en = " << ramadr_reg_en.read() << endl;
  cout << "ramadr_reg_in = " << ramadr_reg_in.read() << endl;
  cout << "ramadr = " << v_ramadr << endl;
  */
}

void pm_fetch_dec::gp_reg_adr()
{
  sc_lv<16> v_ramadr_reg_in = ramadr_reg_in;

  if (!nrst)
    {
      reg_file_adr_space = SC_LOGIC_0;
    }
  else
    {
      if (ramadr_reg_en.read() == 1)
	{
	  if (v_ramadr_reg_in.range(15,5) == const_ram_to_reg)
	    reg_file_adr_space = SC_LOGIC_1;
	  else 
	    reg_file_adr_space = SC_LOGIC_0;
	}
    }
}

void pm_fetch_dec::io_reg_adr()
{
  sc_lv<16> v_ramadr_reg_in = ramadr_reg_in;

  if (!nrst)
    {
      io_file_adr_space = SC_LOGIC_0;
    }
  else
    {
      if (ramadr_reg_en.read() == 1)
	{
	  if ((v_ramadr_reg_in.range(15,5) == const_ram_to_io_a) ||
	      (v_ramadr_reg_in.range(15,5) == const_ram_to_io_b))
	    {
	      io_file_adr_space = SC_LOGIC_1;
	    }
	  else 
	    {
	      io_file_adr_space = SC_LOGIC_0;
	    }
	}
    }
}

// sensitive_pos << clk
void pm_fetch_dec::datamemoryread()
{
  sc_logic  v_ramre = ramre_int;
  sc_lv<16> v_ramadr_reg_in = ramadr_reg_in;

  if (!nrst)
    {
      v_ramre = SC_LOGIC_0;
    }
  else
    {
      {
        if (ramre_int.read() == SC_LOGIC_0)
        {
          if ((/*(v_ramadr_reg_in.range(15,5) != const_ram_to_io_a) && 
		 (v_ramadr_reg_in.range(15,5) != const_ram_to_io_b) && */
	       (v_ramadr_reg_in.range(15,5) != const_ram_to_reg)) && 
	      ((idc_ld_x.read() | idc_ld_y.read() | idc_ldd_y.read() | idc_ld_z.read() | idc_ldd_z.read() | lds_st1.read() | idc_pop.read() | idc_ret.read() | idc_reti.read()) == SC_LOGIC_1))
	    {
	      v_ramre = SC_LOGIC_1;
	    }
        }
        else if (ramre_int.read() == SC_LOGIC_1)
        {
          if ((ld_st.read() | lds_st2.read() | pop_st.read() | ret_st2.read() | reti_st2.read() & ~cpuwait.read()) == SC_LOGIC_1)
          {
            v_ramre = SC_LOGIC_0;
          }
        }
      }
    }
  ramre     = v_ramre;
  ramre_int = v_ramre;
}

void pm_fetch_dec::datamemorywrite()
{
  sc_logic  v_ramwe = ramwe_int.read();
  sc_lv<16> v_ramadr_reg_in = ramadr_reg_in;

  /*
  cout << "datamemorywrite" << endl;
  cout << v_ramadr_reg_in << endl;
  */

  if (!nrst)
    {
      v_ramwe = SC_LOGIC_0;
    }
  else
    {
      if (ramwe_int.read() == 0)
        {
          if ((/*(v_ramadr_reg_in.range(15,5) != const_ram_to_io_a) && 
		 (v_ramadr_reg_in.range(15,5) != const_ram_to_io_b) && */
	       (v_ramadr_reg_in.range(15,5) != const_ram_to_reg)) && 
	      ((idc_st_x.read() | idc_st_y.read() | idc_std_y.read() | idc_st_z.read() | idc_std_z.read() | sts_st1.read() | idc_push.read() | idc_rcall.read() | idc_icall.read() | call_st1.read() | irq_st1.read()) == SC_LOGIC_1))
	    {
	      v_ramwe = SC_LOGIC_1;
	    }
        }
      else if (ramwe_int.read() == 1)
        {
          if ((st_st.read() | sts_st2.read() | push_st.read() | rcall_st2.read() | icall_st2.read() | call_st3.read() | irq_st3.read() & ~cpuwait.read()) == SC_LOGIC_1)
	    {
	      v_ramwe = SC_LOGIC_0;
	    }
        }
    }

  // cout << "v_ramwe = " << v_ramwe << endl;

  ramwe     = v_ramwe;
  ramwe_int = v_ramwe;
}

void pm_fetch_dec::gp_registers_trig()
{
  if (!nrst)
    {
      gp_reg_tmp = "00000000";
    }
  else
    {
      if ((idc_st_x.read() | idc_st_y.read() | idc_std_y.read() | idc_st_z.read() | idc_std_z.read() | idc_sts.read()) == SC_LOGIC_1)
	{
	  gp_reg_tmp = reg_rd_out;
	}
    }
}

void pm_fetch_dec::program_counter_high_store()
{
  sc_uint<16> v_program_counter = program_counter;

  if (!nrst)
    {
      program_counter_high_fr = 0;
      program_counter_low_fr  = 0;
    }
  else
    {
      if ((idc_rcall.read() | idc_icall.read() | call_st1.read() | irq_st1.read()) == SC_LOGIC_1)
	{
	  program_counter_high_fr = v_program_counter.range(15,8);
	  program_counter_low_fr  = v_program_counter.range(7,0);
	}
    }
}

void pm_fetch_dec::program_counter_for_lpm_elpm()
{
  if (!nrst)
    {
      program_counter_tmp = 0;
    }
  else
    {
      if ((idc_lpm.read() | idc_elpm.read()) == SC_LOGIC_1)
	program_counter_tmp = program_counter.read();
    }
}

void pm_fetch_dec::program_counter_both()
{
  sc_uint<16> v_program_counter_in = program_counter_in.read();
  sc_uint<16> v_program_counter = program_counter.read();

  if (!nrst)
    {
      pc_low = 0;
      pc_high = 0;
      program_counter = 0;
    }
  else
    {
      if ((pc_low_en.read() == SC_LOGIC_1) & (pc_high_en.read() == SC_LOGIC_1))
	{
	  v_program_counter = v_program_counter_in;
	  // cout << "setting pc_low = " << v_program_counter_in.range(7,0) << endl;
	}
      else if ((pc_low_en.read() == SC_LOGIC_1) & (pc_high_en.read() == SC_LOGIC_0))
	{
	  v_program_counter = (v_program_counter.range(15,8), v_program_counter_in.range(7,0));
	}
      else if ((pc_low_en.read() == SC_LOGIC_0) & (pc_high_en.read() == SC_LOGIC_1))
	{
	  v_program_counter = (v_program_counter_in.range(15,8), v_program_counter.range(7,0));
	}

      /*
      if (pcwe.read() == SC_LOGIC_1) // halt cpu is on and new pc is being written!
	{
	  v_program_counter = pc_out.read();
	}
      */

      if (irq_st1.read() == SC_LOGIC_1)
	{
	  v_program_counter = v_program_counter_in;
	}
      program_counter = v_program_counter;
      pc_in = v_program_counter;
    }
}

void pm_fetch_dec::program_counter_for_interrupt()
{
  if (!nrst)
    {
      pc_for_interrupt = 0;
    }
  else
    {
      if (irq_start.read() == SC_LOGIC_1)
	{
	  pc_for_interrupt = program_counter.read();
	  cout << "pm_fetch_dec::program_counter_for_interrupt()" << endl;
	  cout << "irq_start = " << irq_start.read() << endl;
	  cout << "pc_for_interrupt = " << program_counter.read() << endl;
	}
    }
}

void pm_fetch_dec::skip_instruction_sm()
{
  if (!nrst)
    {
      nskip_inst_st0 = SC_LOGIC_0;
      skip_inst_st1 = SC_LOGIC_0;
      skip_inst_st2 = SC_LOGIC_0;
    }
  else
    {
      nskip_inst_st0 = (( ~nskip_inst_st0.read()) & skip_inst_start.read()) | (nskip_inst_st0.read() & ( ~((skip_inst_st1.read() & ( ~two_word_inst.read())) | skip_inst_st2.read())));
      skip_inst_st1 = (( ~skip_inst_st1.read()) & (~nskip_inst_st0.read())) & skip_inst_start.read();
      skip_inst_st2 = (( ~skip_inst_st2.read()) & skip_inst_st1.read()) & two_word_inst.read();
    }
}

void pm_fetch_dec::alu_state_machines()
{
  if (!nrst)
    {
      adiw_st = SC_LOGIC_0;
      sbiw_st = SC_LOGIC_0;
    }
  else
    {
      adiw_st = ( ~adiw_st.read()) & idc_adiw.read();
      sbiw_st = ( ~sbiw_st.read()) & idc_sbiw.read();
    }
}

void pm_fetch_dec::lpm_state_machine()
{
  if (!nrst)
    {
      nlpm_st0 = SC_LOGIC_0;
      lpm_st1 = SC_LOGIC_0;
      lpm_st2 = SC_LOGIC_0;
    }
  else
    {
      nlpm_st0 = (( ~nlpm_st0.read()) & (idc_lpm.read() | idc_elpm.read())) | (nlpm_st0.read() & ( ~lpm_st2.read()));
      lpm_st1 = (( ~lpm_st1.read()) & ( ~nlpm_st0.read())) & (idc_lpm.read() | idc_elpm.read());
      lpm_st2 = ( ~lpm_st2.read()) & lpm_st1.read();
    }
}

void pm_fetch_dec::lds_state_machine()
{
  if (!nrst)
    {
      nlds_st0 = SC_LOGIC_0;
      lds_st1 = SC_LOGIC_0;
      lds_st2 = SC_LOGIC_0;
    }
  else
    {
      nlds_st0 = (( ~nlds_st0.read()) & idc_lds.read()) | (nlds_st0.read() & ( ~(lds_st2.read() & ( ~cpuwait.read()))));
      lds_st1 = (( ~lds_st1.read()) & ( ~nlds_st0.read())) & idc_lds.read();
      lds_st2 = (( ~lds_st2.read()) & lds_st1.read()) | (lds_st2.read() & cpuwait.read());
    }
}

void pm_fetch_dec::sts_state_machine()
{
  if (!nrst)
    {
      nsts_st0 = SC_LOGIC_0;
      sts_st1 = SC_LOGIC_0;
      sts_st2 = SC_LOGIC_0;
    }
  else
    {
      nsts_st0 = (( ~nsts_st0.read()) & idc_sts.read()) | (nsts_st0.read() & ( ~(sts_st2.read() & ( ~cpuwait.read()))));
      sts_st1 = (( ~sts_st1.read()) & ( ~nsts_st0.read())) & idc_sts.read();
      sts_st2 = (( ~sts_st2.read()) & sts_st1.read()) | (sts_st2.read() & cpuwait.read());
    }
}

void pm_fetch_dec::jmp_state_machine()
{
  if (!nrst)
    {
      njmp_st0 = SC_LOGIC_0;
      jmp_st1 = SC_LOGIC_0;
      jmp_st2 = SC_LOGIC_0;
    }
  else
    {
      njmp_st0 = (( ~njmp_st0.read()) & idc_jmp.read()) | (njmp_st0.read() & ( ~jmp_st2.read()));
      jmp_st1 = (( ~jmp_st1.read()) & ( ~njmp_st0.read())) & idc_jmp.read();
      jmp_st2 = ( ~jmp_st2.read()) & jmp_st1.read();
    }
}

void pm_fetch_dec::rcall_state_machine()
{
  if (!nrst)
    {
      nrcall_st0 = SC_LOGIC_0;
      rcall_st1 = SC_LOGIC_0;
      rcall_st2 = SC_LOGIC_0;
    }
  else
    {
      nrcall_st0 = (( ~nrcall_st0.read()) & idc_rcall.read()) | (nrcall_st0.read() & ( ~(rcall_st2.read() & ( ~cpuwait.read()))));
      rcall_st1 = ((( ~rcall_st1.read()) & ( ~nrcall_st0.read())) & idc_rcall.read()) | (rcall_st1.read() & cpuwait.read());
      rcall_st2 = ((( ~rcall_st2.read()) & rcall_st1.read()) & ( ~cpuwait.read())) | (rcall_st2.read() & cpuwait.read());
    }
}

void pm_fetch_dec::icall_state_machine()
{
  if (!nrst)
    {
      nicall_st0 = SC_LOGIC_0;
      icall_st1 = SC_LOGIC_0;
      icall_st2 = SC_LOGIC_0;
    }
  else
    {
      nicall_st0 = (( ~nicall_st0.read()) & idc_icall.read()) | (nicall_st0.read() & ( ~(icall_st2.read() & ( ~cpuwait.read()))));
      icall_st1 = ((( ~icall_st1.read()) & ( ~nicall_st0.read())) & idc_icall.read()) | (icall_st1.read() & cpuwait.read());
      icall_st2 = ((( ~icall_st2.read()) & icall_st1.read()) & ( ~cpuwait.read())) | (icall_st2.read() & cpuwait.read());
    }
}

void pm_fetch_dec::call_state_machine()
{
  if (!nrst)
    {
      ncall_st0 = SC_LOGIC_0;
      call_st1 = SC_LOGIC_0;
      call_st2 = SC_LOGIC_0;
      call_st3 = SC_LOGIC_0;
    }
  else
    {
      ncall_st0 = (( ~ncall_st0.read()) & idc_call.read()) | (ncall_st0.read() & ( ~(call_st3.read() & ( ~cpuwait.read()))));
      call_st1 = (( ~call_st1.read()) & ( ~ncall_st0.read())) & idc_call.read();
      call_st2 = (( ~call_st2.read()) & call_st1.read()) | (call_st2.read() & cpuwait.read());
      call_st3 = ((( ~call_st3.read()) & call_st2.read()) & ( ~cpuwait.read())) | (call_st3.read() & cpuwait.read());
    }
}

void pm_fetch_dec::ret_state_machine()
{
  sc_logic v_nret_st0, v_ret_st1, v_ret_st2, v_ret_st3;

  if (!nrst)
    {
      v_nret_st0 = SC_LOGIC_0;
      v_ret_st1 = SC_LOGIC_0;
      v_ret_st2 = SC_LOGIC_0;
      v_ret_st3 = SC_LOGIC_0;
    }
  else
    {
      v_nret_st0 = (( ~nret_st0.read()) & idc_ret.read()) | (nret_st0.read() & ( ~ret_st3.read()));
      v_ret_st1 = ((( ~ret_st1.read()) & ( ~nret_st0.read())) & idc_ret.read()) | (ret_st1.read() & cpuwait.read());
      v_ret_st2 = ((( ~ret_st2.read()) & ret_st1.read()) & ( ~cpuwait.read())) | (ret_st2.read() & cpuwait.read());
      v_ret_st3 = (( ~ret_st3.read()) & ret_st2.read()) & ( ~cpuwait.read());
    }

  /*
  cout << "pm_fetch_dec::ret_state_machine()" << endl;
  cout << "nret_st0 = " << v_nret_st0 << endl;
  cout << "ret_st1 = " << v_ret_st1 << endl;
  cout << "ret_st2 = " << v_ret_st2 << endl;
  cout << "ret_st3 = " << v_ret_st3 << endl;
  */

  nret_st0 = v_nret_st0;
  ret_st1 = v_ret_st1;
  ret_st2 = v_ret_st2;
  ret_st3 = v_ret_st3;
}

void pm_fetch_dec::reti_state_machine()
{
  if (!nrst)
    {
      nreti_st0 = SC_LOGIC_0;
      reti_st1 = SC_LOGIC_0;
      reti_st2 = SC_LOGIC_0;
      reti_st3 = SC_LOGIC_0;
    }
  else
    {
      nreti_st0 = (( ~nreti_st0.read()) & idc_reti.read()) | (nreti_st0.read() & ( ~reti_st3.read()));
      reti_st1 = ((( ~reti_st1.read()) & ( ~nreti_st0.read())) & idc_reti.read()) | (reti_st1.read() & cpuwait.read());
      reti_st2 = ((( ~reti_st2.read()) & reti_st1.read()) & ( ~cpuwait.read())) | (reti_st2.read() & cpuwait.read());
      reti_st3 = (( ~reti_st3.read()) & reti_st2.read()) & ( ~cpuwait.read());
    }
}
void pm_fetch_dec::irq_state_machine()
{
  if (!nrst)
    {
      nirq_st0 = SC_LOGIC_0;
      irq_st1 = SC_LOGIC_0;
      irq_st2 = SC_LOGIC_0;
      irq_st3 = SC_LOGIC_0;
    }
  else
    {
      nirq_st0 = (( ~nirq_st0.read()) & irq_start.read()) | (nirq_st0.read() & ( ~(irq_st3.read() & ( ~cpuwait.read()))));
      irq_st1 = (( ~irq_st1.read()) & ( ~nirq_st0.read())) & irq_start.read();
      irq_st2 = (( ~irq_st2.read()) & irq_st1.read()) | (irq_st2.read() & cpuwait.read());
      irq_st3 = ((( ~irq_st3.read()) & irq_st2.read()) & ( ~cpuwait.read())) | (irq_st3.read() & cpuwait.read());
    }
}

void pm_fetch_dec::irqack_reg()
{
  if (!nrst)
    {
      irqack_int = SC_LOGIC_0;
    }
  else
    {
      irqack_int = ( ~irqack_int.read()) & irq_start.read(); // NJ & ( ~cpuwait.read());
    }
}

void pm_fetch_dec::irqackad_reg()
{
  sc_lv<16> v_irq_vector_adr = irq_vector_adr;

  if (!nrst)
    {
      irqackad_int = "00000";
    }
  else
    {
      irqackad_int = v_irq_vector_adr.range(5,1);
    }
}

void pm_fetch_dec::rjmp_push_pop_ijmp_state_brxx_machine()
{
  if (!nrst)
    {
      rjmp_st = SC_LOGIC_0;
      ijmp_st = SC_LOGIC_0;
      push_st = SC_LOGIC_0;
      pop_st  = SC_LOGIC_0;
      brxx_st = SC_LOGIC_0; 
    }
  else
    {
      rjmp_st = idc_rjmp.read();
      ijmp_st = idc_ijmp.read();
      push_st = (( ~push_st.read()) & idc_push.read()) | (push_st.read() & cpuwait.read());
      pop_st  = (( ~pop_st.read()) & idc_pop.read()) | (pop_st.read() & cpuwait.read());
      brxx_st = (( ~brxx_st.read()) & (idc_brbc.read() | idc_brbs.read())) & bit_test_op_out;
    }
}

//
// For LD/LDD/ST/STD intructions
// ld_st is high if previous instruction was a load
// This helps the processor to execute in exactly 2 instructions
//
// sensitive_pos << clk
void pm_fetch_dec::ld_st_state_machine()
{
  if (!nrst)
    {
      ld_st = SC_LOGIC_0;
      st_st = SC_LOGIC_0;
    }
  else
    {
      ld_st = (( ~ld_st.read()) & (idc_ld_x.read() | idc_ld_y.read() | idc_ldd_y.read() | idc_ld_z.read() | idc_ldd_z.read())) | (ld_st.read() & cpuwait.read());
      st_st = (( ~st_st.read()) & (idc_st_x.read() | idc_st_y.read() | idc_std_y.read() | idc_st_z.read() | idc_std_z.read())) | (st_st.read() & cpuwait.read());
    }
}

void pm_fetch_dec::sbi_cbi_machine()
{
  if (!nrst)
    {
      sbi_st = SC_LOGIC_0;
      cbi_st = SC_LOGIC_0;
      cbi_sbi_io_adr_tmp = "00000";
      cbi_sbi_bit_num_tmp = "000";
    }
  else
    {
      sbi_st = ( ~sbi_st.read()) & idc_sbi.read();
      cbi_st = ( ~cbi_st.read()) & idc_cbi.read();
      cbi_sbi_io_adr_tmp = dex_adr5port.read();
      cbi_sbi_bit_num_tmp = dex_bitop_bitnum.read();
    }
}

//
// Two word instruction detector
// Connected directly to the instruction register
//
// sensitive << instruction_reg
void pm_fetch_dec::two_word_inst_detect()
{
  sc_lv<16> v_instruction_reg = instruction_reg.read();

  if (((v_instruction_reg.range(15,9),v_instruction_reg.range(3,1)) == "1001010111")  | // call
      ((v_instruction_reg.range(15,9),v_instruction_reg.range(3,1)) == "1001010110")  | // jmp
      ((v_instruction_reg.range(15,9),v_instruction_reg.range(3,0)) == "10010000000") | // lds
      ((v_instruction_reg.range(15,9),v_instruction_reg.range(3,0)) == "10010010000"))  // sts
    two_word_inst = SC_LOGIC_1;
  else
    two_word_inst = SC_LOGIC_0;
}

//
// Data extractor
// Connected directly to the instruction register
//
// sensitive << instruction_reg
void pm_fetch_dec::data_extractor()
{
  sc_lv<16> v_instruction_reg = instruction_reg;

  dex_dat8_immed = (v_instruction_reg.range(11,8),v_instruction_reg.range(3,0)); // K, see ldi
  dex_dat6_immed = (v_instruction_reg.range(7,6),v_instruction_reg.range(3,0));  // 
  dex_adr12mem_s = v_instruction_reg.range(11,0); 
  dex_adr6port   = (v_instruction_reg.range(10,9), v_instruction_reg.range(3,0));
  dex_adr5port   = v_instruction_reg.range(7,3);  
  dex_adr_disp   = (v_instruction_reg[13],v_instruction_reg.range(11,10),v_instruction_reg.range(2,0));
  dex_condition  = v_instruction_reg.range(2,0);

  // NUMBER(POSITION) OF TESTING BIT IN SBRC/SBRS/SBIC/SBIS INSTRUCTION
  dex_bitop_bitnum = v_instruction_reg.range(2,0); 
  dex_bitnum_sreg  = v_instruction_reg.range(6,4);    
  dex_adrreg_r     = (v_instruction_reg[9],v_instruction_reg.range(3,0));
  dex_adrreg_d     = v_instruction_reg.range(8,4);

  // OFFSET FOR BRBC/BRBS
  dex_brxx_offset  = v_instruction_reg.range(9,3);

  // ADDRESS OF THE LOW REGISTER FOR ADIW/SBIW INSTRUCTIONS
  dex_adiw_sbiw_reg_adr = v_instruction_reg.range(5,4);

  // dex_adrindreg <= v_instruction_reg.range(3,2);
}

//
// Set signal adiw_sbiw_encoder_out
// R24-R31 ADIW/SBIW address control logic
//
// sensitive << dex_adiw_sbiw_reg_adr
void pm_fetch_dec::set_adiw_sbiw_encoder_out()
{
  sc_lv<5> v_adiw_sbiw_encoder_out;
  sc_lv<2> v_dex_adiw_sbiw_reg_adr = dex_adiw_sbiw_reg_adr.read();

  v_adiw_sbiw_encoder_out = ("11",v_dex_adiw_sbiw_reg_adr,"0");

  adiw_sbiw_encoder_out = v_adiw_sbiw_encoder_out;
}

//
// NOP insert state machine
//
// sensitive << instruction_reg << nop_insert_st << instruction_code_reg
void pm_fetch_dec::nop_insert_sm()
{
  sc_lv<16> v_instruction_code_reg = instruction_code_reg;

  if (nop_insert_st == SC_LOGIC_0)
    v_instruction_code_reg = instruction_reg;
  else
    v_instruction_code_reg = "0000000000000000"; // nop

  instruction_code_reg = v_instruction_code_reg;
}

//
// NOP insert state signal
//
// sensitive << adiw_st << sbiw_st << cbi_st << sbi_st << rjmp_st << ijmp_st << pop_st << push_st << brxx_st << ld_st << st_st << ncall_st0 << nirq_st0 << nret_st0 << nreti_st0 << nlpm_st0 << njmp_st0 << nrcall_st0 << nicall_st0 << nsts_st0 << nlds_st0 << nskip_inst_st0
void pm_fetch_dec::set_nop_insert_st()
{
  sc_logic v_nop_insert_st;

  v_nop_insert_st = adiw_st | sbiw_st | cbi_st | sbi_st | rjmp_st | ijmp_st | pop_st | 
    push_st | brxx_st | ld_st | st_st | ncall_st0 | nirq_st0 | nret_st0 | nreti_st0 | 
    nlpm_st0 | njmp_st0 | nrcall_st0 | nicall_st0 | nsts_st0 | nlds_st0 | nskip_inst_st0;
  nop_insert_st = v_nop_insert_st;
  /*
  cout << "pm_fetch_dec::set_nop_insert_st()" << endl;
  cout << "nop_insert_st = " << v_nop_insert_st << endl;
  */
}

//
// Instruction decoder
//
// sensitive << instruction_code_reg
void pm_fetch_dec::instruction_decoder()
{
  sc_lv<16> icr     = instruction_code_reg;
  sc_lv<4>  icr1512 = icr.range(15,12);
  sc_lv<5>  icr1511 = icr.range(15,11);
  sc_lv<6>  icr1510 = icr.range(15,10);
  sc_lv<7>  icr159  = icr.range(15,9);
  sc_lv<8>  icr158  = icr.range(15,8);

#if !defined(SYNTHESIS) && defined(PRINTINST)
  printf("pm_fetch_dec::instruction_decoder()\n");
  cout << "inst = " << instruction_code_reg << endl;
  sc_lv<4> icr0, icr1, icr2, icr3;
  icr3 = icr.range(15,12);
  icr2 = icr.range(11,8);
  icr1 = icr.range(7,4);
  icr0 = icr.range(3,0);

  sc_uint<4> xcr0, xcr1, xcr2, xcr3;
  xcr3 = icr3;
  xcr2 = icr2;
  xcr1 = icr1;
  xcr0 = icr0;

  sc_lv<12> k = icr.range(11,0);
  sc_int<12> i_k = k;

  sc_lv<7> k2 = icr.range(9,3);
  sc_int<7> i_k2 = k2;

  sc_lv<5> p = icr.range(7,3);
  sc_uint<5> i_p = p;

  unsigned int tmp;

  sc_lv<5> dreg; sc_uint<5> i_dreg;
  dreg[4] = icr[8]; dreg[3] = icr[7]; dreg[2] = icr[6]; dreg[1] = icr[5]; dreg[0] = icr[4];
  i_dreg = dreg;
  sc_lv<5> rreg; sc_uint<5> i_rreg;
  rreg[4] = icr[9]; rreg[3] = icr[3]; rreg[2] = icr[2]; rreg[1] = icr[1]; rreg[0] = icr[0];
  i_rreg = rreg;

  sc_lv<5> r; sc_uint<5> i_r;
  r[4] = icr[8]; r[3] = icr[7]; r[2] = icr[6]; r[1] = icr[5]; r[0] = icr[4];
  i_r = r;
  sc_lv<6> q; sc_uint<6> i_q;
  q[5] = icr[13]; q[4] = icr[11]; q[3] = icr[10]; q[2] = icr[2]; q[1] = icr[1]; q[0] = icr[0];
  i_q = q;

  sc_lv<6> K; sc_uint<6> i_K;
  K[5] = icr[7]; K[4] = icr[6]; K[3] = icr[3]; K[2] = icr[2]; K[1] = icr[1]; K[0] = icr[0];
  i_K = K;

  sc_lv<3> s; sc_uint<3> i_s;
  // s[2] = icr[2]; s[1] = icr[1]; s[0] = icr[0];
  s = icr.range(2,0);
  i_s = s;
#endif

  idc_andi  = SC_LOGIC_0;
  idc_cpi   = SC_LOGIC_0;
  idc_ldi   = SC_LOGIC_0;
  idc_ori   = SC_LOGIC_0;
  idc_rcall = SC_LOGIC_0;
  idc_rjmp  = SC_LOGIC_0;
  idc_sbci  = SC_LOGIC_0;
  idc_subi  = SC_LOGIC_0;

  if (icr1512 == "0111")
    {
      idc_andi = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      tmp = (unsigned int)xcr2;
      tmp = tmp << 4;
      tmp = tmp + ((unsigned int)xcr0);
      printf("instruction: andi  r%d, %d\n", (unsigned int)xcr1+16, tmp);
#endif
    }
  else if (icr1512 == "0011")
    {
      idc_cpi = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      tmp = (unsigned int)xcr2;
      tmp = tmp << 4;
      tmp = tmp + ((unsigned int)xcr0);
      printf("instruction: cpi   r%d, %d\n", (unsigned int)xcr1+16, tmp);
#endif
    }
  else if (icr1512 == "1110")
    {
      idc_ldi  = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      tmp = (unsigned int)xcr2;
      tmp = tmp << 4;
      tmp = tmp + ((unsigned int)xcr0);
      // NB! ldi loads register 16 to 31
      printf("instruction: ldi   r%02d, 0x%02x\n", (unsigned int)xcr1+16, tmp);
#endif
    }
  else if (icr1512 == "0110")
    {
      idc_ori = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      tmp = (unsigned int)xcr2;
      tmp = tmp << 4;
      tmp = tmp + ((unsigned int)xcr0);
      // NB! ori loads register 16 to 31
      printf("instruction: ori   r%02d, 0x%02x\n", (unsigned int)xcr1+16, tmp);
#endif
    }
  else if (icr1512 == "1101")
    {
      idc_rcall = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: rcall  +%03x (+%d)\n", (int)i_k, (int)i_k);
#endif
    }
  else if (icr1512 == "1100")
    {
      idc_rjmp = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: rjmp   %03x (%d)\n", (int)i_k, (int)i_k);
#endif
    }
  else if (icr1512 == "0100")
    {
      idc_sbci = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      tmp = (unsigned int)xcr2;
      tmp = tmp << 4;
      tmp = tmp + ((unsigned int)xcr0);
      printf("instruction: sbci  r%02d, 0x%02x\n", (unsigned int)xcr1+16, tmp);
#endif
    }
  else if (icr1512 == "0101")
    {
      idc_subi = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      tmp = (unsigned int)xcr2;
      tmp = tmp << 4;
      tmp = tmp + ((unsigned int)xcr0);
      // NB! ldi loads register 16 to 31
      printf("instruction: subi  r%02d, 0x%02x\n", (unsigned int)xcr1+16, tmp);
#endif
    }
  else {}

  idc_in   = SC_LOGIC_0;
  idc_out  = SC_LOGIC_0;

  if (icr1511 == "10110")
    {
      idc_in = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      sc_lv<6> P; sc_uint<6> i_P;
      P[5] = icr[10]; P[4] = icr[9]; P[3] = icr[3]; P[2] = icr[2]; P[1] = icr[1]; P[0] = icr[0];
      i_P = P;
      printf("instruction: in    r%d, %d\n", (unsigned int)i_r, (unsigned int)i_P);
#endif
    }
  else if (icr1511 == "10111")
    {
      idc_out = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      sc_lv<6> P; sc_uint<6> i_P;
      P[5] = icr[10]; P[4] = icr[9]; P[3] = icr[3]; P[2] = icr[2]; P[1] = icr[1]; P[0] = icr[0];
      i_P = P;
      printf("instruction: out   %d, r%d\n", (unsigned int)i_P, (unsigned int)i_r);
#endif
    }
  else {}

  idc_adc  = SC_LOGIC_0;
  idc_add  = SC_LOGIC_0;
  idc_and  = SC_LOGIC_0;
  idc_brbc = SC_LOGIC_0;
  idc_brbs = SC_LOGIC_0;
  idc_cp   = SC_LOGIC_0;
  idc_cpc  = SC_LOGIC_0;
  idc_cpse = SC_LOGIC_0;
  idc_eor  = SC_LOGIC_0;
  idc_mov  = SC_LOGIC_0;
  idc_mul  = SC_LOGIC_0;
  idc_or   = SC_LOGIC_0;
  idc_sbc  = SC_LOGIC_0;
  idc_sub  = SC_LOGIC_0;

  if (icr1510 == "000111")
    {
      idc_adc = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: adc   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "000011")
    {
      idc_add = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: add   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "001000")
    {
      idc_and = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: and   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "111101")
    {
      idc_brbc = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: brbc  %d, %04x (%d)\n", (unsigned int)i_s, (int)i_k2, (int)i_k2);
      printf("sreg = 0x%02X\n", (unsigned int)(sc_uint<8>)sreg_fl_in.read());
#endif
    }
  else if (icr1510 == "111100")
    {
      idc_brbs = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: brbs  %d, %04x (%d)\n", (unsigned int)i_s, (int)i_k2, (int)i_k2);
      printf("sreg = 0x%02X\n", (unsigned int)(sc_uint<8>)sreg_fl_in.read());
#endif
    }
  else if (icr1510 == "000101")
    {
      idc_cp = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: cp    r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "000001")
    {
      idc_cpc = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: cpc   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "000100")
    {
      idc_cpse = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: cpse  \n");
#endif
    }
  else if (icr1510 == "001001")
    {
      idc_eor = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: eor   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "001011")
    {
      idc_mov = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: mov   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "100111")
    {
      idc_mul = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: mul   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "001010")
    {
      idc_or    = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: or    r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "000010")
    {
      idc_sbc = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      // printf("instruction: sbc\n");
      printf("instruction: sbc   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else if (icr1510 == "000110")
    {
      idc_sub = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sub   r%d,r%d\n", (unsigned int)i_dreg, (unsigned int)i_rreg);
#endif
    }
  else {}

  idc_asr  = SC_LOGIC_0;
  idc_bld  = SC_LOGIC_0;
  idc_bst  = SC_LOGIC_0;
  idc_call = SC_LOGIC_0;
  idc_com  = SC_LOGIC_0;
  idc_dec  = SC_LOGIC_0;
  idc_inc  = SC_LOGIC_0;
  idc_jmp  = SC_LOGIC_0;
  idc_ld_x = SC_LOGIC_0;
  idc_ld_y = SC_LOGIC_0;
  idc_ld_z = SC_LOGIC_0;
  idc_lds  = SC_LOGIC_0;
  idc_lsr  = SC_LOGIC_0;
  idc_neg  = SC_LOGIC_0;
  idc_ror  = SC_LOGIC_0;
  idc_pop  = SC_LOGIC_0;
  idc_push = SC_LOGIC_0;
  idc_sbrc = SC_LOGIC_0;
  idc_sbrs = SC_LOGIC_0;
  idc_st_x = SC_LOGIC_0;
  idc_st_y = SC_LOGIC_0;
  idc_st_z = SC_LOGIC_0;
  idc_sts  = SC_LOGIC_0;
  idc_swap = SC_LOGIC_0;

  if (icr159 == "1001010")
    {
      if (icr.range(3,0) == "0101")
	{
	  idc_asr = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: asr   \n");
#endif
	}
      else if (icr.range(3,1) == "111") 
	{
	  idc_call = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: call  <addr>\n");
#endif
	}
      else if (icr.range(3,0) == "0000")
	{
	  idc_com = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: com   r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1010")
	{
	  idc_dec = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: dec   r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "0011")
	{
	  idc_inc = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: inc   r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,1) == "110")
	{
	  idc_jmp = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: jmp   <addr>\n");
#endif
	}
      else if (icr.range(3,0) == "0110")
	{
	  idc_lsr = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: lsr   \n");
#endif
	}
      if (icr.range(3,0) == "0001")
	{
	  idc_neg = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: neg   r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "0111")
	{
	  idc_ror = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ror   r%d\n", (unsigned int)i_dreg);
#endif
	}
      if (icr.range(3,0) == "0010")
	{
	  idc_swap = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: swap  \n");
#endif
	}
    }
  else if (icr159 == "1111100")
    {
      if (icr[3] == SC_LOGIC_0)
	{
	  idc_bld = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: bld   \n");
#endif
	}
    }
  else if (icr159 == "1111101")
    {
      idc_bst = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: bst   \n");
#endif
    }
  else if (icr159 == "1001000")
    {
      if (icr.range(3,0) == "0000")
	{
	  idc_lds = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: lds   r%d, <data>\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1100")
	{
	  idc_ld_x = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_x  r%d, X\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1101")
	{
	  idc_ld_x = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_x  r%d, X+\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1110")
	{
	  idc_ld_x = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_x  r%d, -X\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1001")
	{
	  idc_ld_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_y  r%d, Y+\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1010")
	{
	  idc_ld_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_y  r%d, -Y\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "0001")
	{
	  idc_ld_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_z  r%d, Z+\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "0010")
	{
	  idc_ld_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_z  r%d, -Z\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1111")
	{
	  idc_pop = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: pop   r%d\n", (unsigned int)i_dreg);
#endif
	}
    }
  else if (icr159 == "1000000")
    {
      if (icr.range(3,0) == "1000")
	{
	  idc_ld_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ld_y  r%d, Y\n", (unsigned int)i_dreg);
#endif
	}
    }
  else if (icr159 == "1000001")
    {
      if (icr.range(3,0) == "1000")
	{
	  idc_st_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_y  Y, r%d\n", (unsigned int)i_dreg);
#endif
	}
      if (icr.range(3,0) == "1000")
	{
	  idc_st_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_z  Z, r%d\n", (unsigned int)i_dreg);
#endif
	}
    }
  else if (icr159 == "1001001")
    {
      if (icr.range(3,0) == "1111")
	{
	  idc_push = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: push  r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1100")
	{
	  idc_st_x = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_x  X, r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1101")
	{
	  idc_st_x = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_x  X+, r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1110")
	{
	  idc_st_x = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_x  -X, r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1001")
	{
	  idc_st_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_y  Y+, r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "1010")
	{
	  idc_st_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_y  -Y, r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "0001")
	{
	  idc_st_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_z  Z+, r%d\n", (unsigned int)i_dreg);
#endif
	}
      else if (icr.range(3,0) == "0010")
	{
	  idc_st_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: st_z  -Z, r%d\n", (unsigned int)i_dreg);
#endif
	}
      if (icr.range(3,0) == "0000")
	{
	  idc_sts = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: sts   r%d, <data>\n", (unsigned int)i_dreg);
#endif
	}
    }
  else if (icr159 == "1111110")
    {
      idc_sbrc = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sbrc  \n");
#endif
    }
  else if (icr159 == "1111111")
    {
      idc_sbrs = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sbrs  \n");
#endif
    }
  else {}
  
  idc_adiw  = SC_LOGIC_0;
  idc_cbi   = SC_LOGIC_0;
  idc_icall = SC_LOGIC_0;
  idc_ijmp  = SC_LOGIC_0;
  idc_sbi   = SC_LOGIC_0;
  idc_sbic  = SC_LOGIC_0;
  idc_sbis  = SC_LOGIC_0;
  idc_sbiw  = SC_LOGIC_0;

  if (icr158 == "10010110")
    {
      idc_adiw = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      sc_lv<2> d; sc_uint<2> i_d;
      d[1] = icr[5]; d[0] = icr[4];
      i_d = d;
      // i_d = (i_d * 2) + 24;
      printf("instruction: adiw  r%d, %d\n",((unsigned int)i_d)*2+24, (unsigned int)i_K);
#endif
    }
  else if (icr158 == "10011000")
    {
      idc_cbi = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: cbi   io%d, %d\n", (unsigned int)i_p, (unsigned int)i_s);
#endif
    }
  else if (icr158 == "10010101")
    {
      if (icr.range(3,0) == "1001")
	{
	  idc_icall = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: icall <addr>\n");
#endif
	}
    }
  else if (icr158 == "10010100")
    {
      if (icr.range(3,0) == "1001")
	{
	  idc_ijmp = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
	  printf("instruction: ijmp  <addr>\n");
#endif
	}
    }
  else if (icr158 == "10011010")
    {
      idc_sbi = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sbi   io%d, %d\n", (unsigned int)i_p, (unsigned int)i_s);
#endif
    }
  else if (icr158 == "10011001")
    {
      idc_sbic = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sbic  \n");
#endif
    }
  else if (icr158 == "10011011")
    {
      idc_sbis = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sbis  \n");
#endif
    }
  else if (icr158 == "10010111")
    {
      idc_sbiw = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      sc_lv<2> d; sc_uint<2> i_d;
      d[1] = icr[5]; d[0] = icr[4];
      i_d = d;
      // i_d = i_d * 2 + 24;
      printf("instruction: sbiw  r%d, %d\n",((unsigned int)i_d)*2+24, (unsigned int)i_K);
#endif
    }
  else {}

  // The rest of the cases:
  idc_bclr  = SC_LOGIC_0;
  idc_bset  = SC_LOGIC_0;
  idc_ldd_y = SC_LOGIC_0;
  idc_ldd_z = SC_LOGIC_0;
  idc_ret   = SC_LOGIC_0;
  idc_reti  = SC_LOGIC_0;
  idc_sleep = SC_LOGIC_0;
  idc_std_y = SC_LOGIC_0;
  idc_std_z = SC_LOGIC_0;
  idc_wdr   = SC_LOGIC_0;

  if ((icr.range(15,7) == "100101001") & (icr.range(3,0) == "1000"))
    {
      idc_bclr = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      sc_lv<3> s; sc_uint<3> i_s;
      s[2] = icr[6]; s[1] = icr[5]; s[0] = icr[4];
      i_s = s;
      printf("instruction: bclr  %d (ITHS.VNZC)\n", (unsigned int)i_s);
#endif
    }
  if ((icr.range(15,7) == "100101000") & (icr.range(3,0) == "1000"))
    {
      idc_bset = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      sc_lv<3> s; sc_uint<3> i_s;
      s = icr.range(6,4);
      // s[2] = icr[6]; s[1] = icr[5]; s[0] = icr[4];
      i_s = s;
      printf("instruction: bset  %d (ITHS.VNZC)\n", (unsigned int)i_s);
#endif
    }
  if ((icr.range(15,14) == "10") & (icr[12] == SC_LOGIC_0) & (icr[9] == SC_LOGIC_0) & (icr[3] == SC_LOGIC_1))
    {
      idc_ldd_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: ldd_y r%d, (y+%d)\n", (unsigned int)i_r, (unsigned int)i_q);
#endif
    }
  if ((icr.range(15,14) == "10") & (icr[12] == SC_LOGIC_0) & (icr[9] == SC_LOGIC_0) & (icr[3] == SC_LOGIC_0))
    {
      idc_ldd_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: ldd_z r%d, (y+%d)\n", (unsigned int)i_r, (unsigned int)i_q);
#endif
    }
  if ((icr.range(15,7) == "100101010") & (icr.range(4,0) == "01000"))
    {
      idc_ret = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: ret   \n");
#endif
    }
  if ((icr.range(15,7) == "100101010") & (icr.range(4,0) == "11000"))
    {
      idc_reti = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: reti  \n");
#endif
    }
  if ((icr.range(15,5) == "10010101100") & (icr.range(3,0) == "1000"))
    {
      idc_sleep = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: sleep \n");
#endif
    }
  if ((icr.range(15,14) == "10") & (icr[12] == SC_LOGIC_0) & (icr[9] == SC_LOGIC_1) & (icr[3] == SC_LOGIC_1))
    {
      idc_std_y = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      // STD Y+q, Rr
      printf("instruction: std_y (Y+%d), r%d\n", (unsigned int)i_q, (unsigned int)i_r);
#endif
    }
  if ((icr.range(15,14) == "10") & (icr[12] == SC_LOGIC_0) & (icr[9] == SC_LOGIC_1) & (icr[3] == SC_LOGIC_0))
    {
      idc_std_z = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: std_z (Z+%d), r%d\n", (unsigned int)i_q, (unsigned int)i_r);
#endif
    }
  if ((icr.range(15,5) == "10010101101") & (icr.range(3,0) == "1000"))
    {
      idc_wdr = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: wdr   [NOT IMPLEMENTED]\n");
#endif
    }

  // Complete instructions
  idc_elpm = SC_LOGIC_0;
  idc_lpm  = SC_LOGIC_0;
  idc_nop  = SC_LOGIC_0;
  
  if (icr == "1001010111011000")
    {
      idc_elpm = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: elpm (r0 = imem[RAMZ,Z])\n");
#endif
    }
  if (icr == "1001010111001000")
    {
      idc_lpm = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: lpm  (r0 = imem[Z])\n");
#endif
    }
  if (icr == "0000000000000000")
    {
      idc_nop = SC_LOGIC_1;
#if !defined(SYNTHESIS) && defined(PRINTINST)
      printf("instruction: nop  \n");
#endif
    }
}

//
// Post increment or pre decrement
// For ld/st instructions
//
// sensitive << instruction_code_reg << idc_st_x << idc_st_y << idc_st_z << idc_ld_x << idc_ld_y << idc_ld_z
void pm_fetch_dec::incdec_signals()
{
  sc_lv<16> icr = instruction_code_reg.read();
  sc_logic v_idc_psinc;
  sc_logic v_idc_prdec;

  if ((icr.range(1,0) == "01") && ((idc_st_x | idc_st_y | idc_st_z | idc_ld_x | idc_ld_y | idc_ld_z) == SC_LOGIC_1))
    v_idc_psinc = SC_LOGIC_1;
  else
    v_idc_psinc = SC_LOGIC_0;

  if ((icr.range(1,0) == "10") && ((idc_st_x | idc_st_y | idc_st_z | idc_ld_x | idc_ld_y | idc_ld_z) == SC_LOGIC_1))
    v_idc_prdec = SC_LOGIC_1;
  else
    v_idc_prdec = SC_LOGIC_0;

  // POST INCREMENT/PRE DECREMENT FOR THE X,Y,Z REGISTERS
  post_inc  = v_idc_psinc;
  idc_psinc = v_idc_psinc;

  pre_dec   = v_idc_prdec;
  idc_prdec = v_idc_prdec;

  /*
  cout << "pm_fetch_dec::incdec_signals()" << endl;
  cout << "post_inc = " << v_idc_psinc << endl;
  cout << "pre_dec  = " << v_idc_prdec << endl;
  */
}

//
// Set write enable signals form ramadr_reg
// Set ramadr mux
//
// sensitive << sph_out << spl_out << reg_h_out << dex_adr_disp
// sensitive << idc_ld_x << idc_ld_y << idc_ldd_y << idc_ld_z << idc_ldd_z << lds_st1 << idc_st_x
// sensitive << idc_st_y << idc_std_y << idc_st_z << idc_std_z << sts_st1 << idc_push << idc_pop
// sensitive << idc_rcall << rcall_st1 << cpuwait << idc_icall << icall_st1 << call_st1 << call_st2
// sensitive << irq_st1 << irq_st2 << idc_ret << ret_st1 << idc_reti << reti_st1
// sensitive << instruction_reg
void pm_fetch_dec::ramadr_signals()
{
  sc_logic  v_ramadr_reg_en;
  sc_lv<16> v_ramadr_reg_in;
  sc_lv<16> x_ramadr_reg_in;
  sc_uint<16> i_ramadr_reg_in;

  sc_lv<8> v_sph_out = sph_out.read();
  sc_lv<8> v_spl_out = spl_out.read();

  sc_lv<16> v_reg_h_out = reg_h_out.read();
  sc_uint<16> i_reg_h_out = v_reg_h_out;

  sc_lv<6>   v_dex_adr_disp = dex_adr_disp.read();
  sc_uint<6> i_dex_adr_disp = v_dex_adr_disp;

  x_ramadr_reg_in = (v_sph_out,v_spl_out);
  i_ramadr_reg_in = x_ramadr_reg_in;
  i_ramadr_reg_in = i_ramadr_reg_in + 1;
  x_ramadr_reg_in = i_ramadr_reg_in;

  v_ramadr_reg_en = idc_ld_x | idc_ld_y | idc_ldd_y | idc_ld_z | idc_ldd_z | lds_st1 |    // LD/LDD/LDS 
    idc_st_x | idc_st_y | idc_std_y | idc_st_z | idc_std_z | sts_st1 |    // ST/STS/STS
    idc_push | idc_pop | idc_rcall | /*push_st | pop_st | */ // NB!
    (rcall_st1.read() &  ~cpuwait.read()) | idc_icall | (icall_st1.read() & ~cpuwait.read()) | // RCALL/ICALL
    call_st1 | (call_st2 & ~cpuwait.read()) | irq_st1 | (irq_st2 & ~cpuwait.read()) | // CALL/IRQ
    idc_ret | (ret_st1 & ~cpuwait.read()) | idc_reti | (reti_st1 & ~cpuwait.read());  // RET/RETI

  if ((idc_rcall | (rcall_st1 & ~cpuwait.read()) | idc_icall | (icall_st1 & ~cpuwait.read()) | // RCALL/ICALL
       call_st1 | (call_st2 & ~cpuwait.read()) | irq_st1 | (irq_st2 & ~cpuwait.read()) | // CALL/IRQ
       idc_push) == SC_LOGIC_1)
    v_ramadr_reg_in = (v_sph_out,v_spl_out);
  else if ((idc_ret | (ret_st1 & ~cpuwait.read()) | idc_reti | (reti_st1 & ~cpuwait.read()) | idc_pop) == SC_LOGIC_1)
    v_ramadr_reg_in = x_ramadr_reg_in;
  else if ((lds_st1 | sts_st1) == SC_LOGIC_1)
    v_ramadr_reg_in = instruction_reg;
  else if ((idc_ld_x | idc_ld_y | idc_ld_z | idc_st_x | idc_st_y | idc_st_z) == SC_LOGIC_1)
    v_ramadr_reg_in = reg_h_out;
  else
    {
      i_ramadr_reg_in = i_reg_h_out + i_dex_adr_disp;
      v_ramadr_reg_in = i_ramadr_reg_in;
    }
  ramadr_reg_en = v_ramadr_reg_en;
  ramadr_reg_in = v_ramadr_reg_in;

  /*
  cout << "pm_fetch_dec::ramadr_signals()" << endl;
  cout << "ramadr_reg_in = " << v_ramadr_reg_in << endl;
  cout << "ramadr_reg_en = " << v_ramadr_reg_en << endl;
  cout << "reg_h_out = " << reg_h_out.read() << endl;
  */
}

//
// WRITE ENABLE FOR Rd REGISTERS
//
// sensitive << dex_adrreg_d << ramadr_int << x_reg_rd_adr
// sensitive << idc_adc << idc_add << idc_adiw << adiw_st << idc_sub << idc_subi << idc_sbc 
// sensitive << idc_sbci << idc_sbiw << sbiw_st << idc_and << idc_andi << idc_or << idc_ori << idc_eor
// sensitive << idc_com << idc_neg << idc_inc << idc_dec << idc_lsr << idc_ror << idc_asr << idc_swap
// sensitive << idc_mov << idc_bld << idc_in << idc_ldi << idc_cpi
// sensitive << alu_reg_wr << idc_bld << pop_st << ld_st << lds_st2 << st_st << sts_st2 << lpm_st2 << reg_file_adr_space
void pm_fetch_dec::rd_enable_signals()
{
  sc_lv<5> v_dex_adrreg_d = dex_adrreg_d;
  sc_lv<16> v_ramadr_int = ramadr_int;

  // Targets
  sc_lv<5> v_reg_rd_adr, v_reg_rr_adr;

  alu_reg_wr = idc_adc | idc_add | idc_adiw | adiw_st | idc_sub | idc_subi | idc_sbc | idc_sbci |
    idc_sbiw | sbiw_st | idc_and | idc_andi | idc_or | idc_ori | idc_eor | idc_com |
    idc_neg | idc_inc | idc_dec | idc_lsr | idc_ror | idc_asr | idc_swap;


  reg_rd_wr = idc_in | alu_reg_wr | idc_bld |       // ALU INSTRUCTIONS + IN/BLD INSRTRUCTION
    (pop_st | ld_st | lds_st2) |                    // POP/LD/LDD/LDS INSTRUCTIONS
    ((st_st | sts_st2) & reg_file_adr_space)|       // ST/STD/STS INSTRUCTION 	      
    lpm_st2 | idc_ldi | idc_mov;                    // LPM/LDI/MOV INSTRUCTION


  if ((idc_subi | idc_sbci | idc_andi | idc_ori | idc_cpi | idc_ldi) == SC_LOGIC_1)
    v_reg_rd_adr = ("1",v_dex_adrreg_d.range(3,0));
  else if (lpm_st2 == SC_LOGIC_1)
    v_reg_rd_adr = "00000";
  else if ((idc_adiw | idc_sbiw) == SC_LOGIC_1)
    v_reg_rd_adr = adiw_sbiw_encoder_out;
  else if ((adiw_st | sbiw_st) == SC_LOGIC_1)
    v_reg_rd_adr = adiw_sbiw_encoder_mux_out;
  else if ((((st_st | sts_st2) & ~reg_file_adr_space.read()) | ld_st | lds_st2 | pop_st) == SC_LOGIC_1)
    v_reg_rd_adr = dex_adrreg_d_latched;
  else if (((st_st | sts_st2) & reg_file_adr_space) == SC_LOGIC_1)
    v_reg_rd_adr = v_ramadr_int.range(4,0);
  else if (push_st == SC_LOGIC_1)
    v_reg_rd_adr = x_reg_rd_adr;
  else
    v_reg_rd_adr = dex_adrreg_d;

  reg_rd_adr = v_reg_rd_adr;

  if (((ld_st | lds_st2) & reg_file_adr_space) == SC_LOGIC_1)
    v_reg_rr_adr = v_ramadr_int.range(4,0);
  else if (((st_st | sts_st2) & reg_file_adr_space) == SC_LOGIC_1)
    v_reg_rr_adr = dex_adrreg_d_latched;
  else
    v_reg_rr_adr = dex_adrreg_r;
  reg_rr_adr = v_reg_rr_adr;
}

//
// Keeps reg_rd_adr so it can be set throughout push instruction (2 cycles)
//
// sensitive_pos << clk
void pm_fetch_dec::reg_rd_adr_register()
{
  if (idc_push == 1)
    x_reg_rd_adr = reg_rd_adr;
}

//
// Register rd input mux
//
// sensitive << reg_z_out << instruction_reg
// sensitive << idc_in << lds_st2 << ld_st << reg_file_adr_space << pop_st
// sensitive << dbusin << reg_rr_out << gp_reg_tmp << bld_op_out << reg_rr_out
// sensitive << dex_dat8_immed << alu_data_out
void pm_fetch_dec::rd_input_signals()
{
  sc_lv<8> v_reg_rd_in;
  sc_lv<16> v_reg_z_out = reg_z_out;
  sc_lv<16> ir = instruction_reg;

  if ((((lds_st2 | ld_st) & ~reg_file_adr_space.read()) | pop_st | idc_in) == SC_LOGIC_1)
    v_reg_rd_in = dbusin; // FROM INPUT DATA BUS
  else if (((lds_st2 | ld_st) & reg_file_adr_space.read()) == SC_LOGIC_1)
    v_reg_rd_in = reg_rr_out;
  else if (((st_st | sts_st2) & reg_file_adr_space.read()) == SC_LOGIC_1)
    v_reg_rd_in = gp_reg_tmp; // ST/STD/STS &  ADDRESS FROM 0 TO 31 (REGISTER FILE)
  else if (idc_bld == SC_LOGIC_1)
    v_reg_rd_in = bld_op_out;
  else if (idc_mov == SC_LOGIC_1)
    v_reg_rd_in = reg_rr_out;
  else if ((lpm_st2 == SC_LOGIC_1) && (v_reg_z_out[0] == SC_LOGIC_1))
    v_reg_rd_in = ir.range(15,8);
  else if ((lpm_st2 == SC_LOGIC_1) && (v_reg_z_out[0] == SC_LOGIC_0))
    v_reg_rd_in = ir.range(7,0);
  else if (idc_ldi == SC_LOGIC_1)
    v_reg_rd_in = dex_dat8_immed;
  else 
    v_reg_rd_in = alu_data_out;

  reg_rd_in = v_reg_rd_in;
}

//
// IORE and IORW logic
//
// sensitive << idc_in << idc_sbi << idc_cbi << idc_sbic << idc_sbis << ld_st << lds_st2 << io_file_adr_space << idc_out << sbi_st << cbi_st << st_st << sts_st2
void pm_fetch_dec::iore_logic()
{
  sc_logic v_iore;
  sc_logic v_iowe;

  // IN/SBI/CBI
  v_iore = idc_in | idc_sbi | idc_cbi | idc_sbic | idc_sbis | ((ld_st | lds_st2) & io_file_adr_space);

  // OUT/SBI/CBI + !! ST/STS/STD
  if (((idc_out | sbi_st | cbi_st) | ((st_st | sts_st2) & io_file_adr_space)) == SC_LOGIC_1)
    v_iowe = SC_LOGIC_1;
  else 
    v_iowe = SC_LOGIC_0;

  iore     = v_iore;
  iore_int = v_iore;
  iowe     = v_iowe;
  iowe_int = v_iowe;
}

//
// adr bus multiplexor
//
// sensitive << ramadr_int << idc_in << idc_out << dex_adr6port << idc_cbi << idc_sbi << idc_sbic << idc_sbis << dex_adr5port << cbi_st << sbi_st << cbi_sbi_io_adr_tmp
void pm_fetch_dec::adr_bus_mux()
{
  sc_lv<16> v_ramadr_int = ramadr_int;
  sc_lv<5> v_dex_adr5port = dex_adr5port;
  sc_lv<5> v_cbi_sbi_io_adr_tmp = cbi_sbi_io_adr_tmp;

  // For output
  sc_lv<6> v_adr_int;

  if ((idc_in | idc_out) == SC_LOGIC_1)
    v_adr_int = dex_adr6port; // IN/OUT INSTRUCTIONS  
  else if ((idc_cbi | idc_sbi | idc_sbic | idc_sbis) == SC_LOGIC_1)
    v_adr_int = ("0",v_dex_adr5port);  // CBI/SBI (READ PHASE) + SBIS/SBIC
  else if ((cbi_st | sbi_st) == SC_LOGIC_1)
    v_adr_int = ("0",v_cbi_sbi_io_adr_tmp);  // CBI/SBI (WRITE PHASE)
  else 
    v_adr_int = (v_ramadr_int[6], v_ramadr_int.range(4,0));  // LD/LDS/LDD/ST/STS/STD

  adr     = (sc_uint<6>)v_adr_int;
  adr_int = v_adr_int;
}

//
// dbusout mux
//
// sensitive << reg_rd_out << gp_reg_tmp << bitpr_io_out << program_counter << program_counter_high_fr << program_counter_low_fr << pc_for_interrupt
// sensitive << idc_push << idc_st_x << idc_st_y << idc_std_y << idc_st_z << idc_std_z
// sensitive << st_st << sts_st1 << sts_st2 << cbi_st << sbi_st << idc_rcall << idc_icall
// sensitive << call_st1 << rcall_st1 << icall_st1 << call_st2 << irq_st1 << irq_st2 << idc_out
// sensitive << rcall_st2
void pm_fetch_dec::dbusout_mux()
{
  sc_lv<8>  v_reg_rd_out = reg_rd_out;
  sc_lv<8>  v_gp_reg_tmp = gp_reg_tmp;
  sc_lv<8>  v_bitpr_io_out = bitpr_io_out;
  sc_uint<16> v_program_counter = program_counter;
  sc_uint<8>  v_program_counter_high_fr = program_counter_high_fr;
  sc_uint<8>  v_program_counter_low_fr = program_counter_low_fr;
  sc_uint<16> v_pc_for_interrupt = pc_for_interrupt;

  // For output
  sc_lv<8> v_dbusout_int;

  DBUS_MUX_GENERATE(0);
  DBUS_MUX_GENERATE(1);
  DBUS_MUX_GENERATE(2);
  DBUS_MUX_GENERATE(3);
  DBUS_MUX_GENERATE(4);
  DBUS_MUX_GENERATE(5);
  DBUS_MUX_GENERATE(6);
  DBUS_MUX_GENERATE(7);

  dbusout     = v_dbusout_int;
  dbusout_int = v_dbusout_int;

  /*
  cout << "pm_fetch_dec::dbusout_mux()" << endl;
  cout << "dbusout = " << v_dbusout_int << endl;
  */
}

//
// ALU connection
//
// sensitive << idc_subi << idc_sbci << idc_andi << idc_ori << idc_cpi << dex_dat8_immed << idc_adiw << idc_sbiw << dex_dat6_immed << adiw_st << sbiw_st << reg_rr_out << reg_rd_out
void pm_fetch_dec::alu_connection()
{
  sc_lv<6> v_dex_dat6_immed = dex_dat6_immed.read();

  sc_lv<8> v_alu_data_r_in;

  if ((idc_subi | idc_sbci | idc_andi | idc_ori | idc_cpi) == SC_LOGIC_1)
    v_alu_data_r_in = dex_dat8_immed.read();
  else if ((idc_adiw | idc_sbiw) == SC_LOGIC_1)
    v_alu_data_r_in = ("00",v_dex_dat6_immed);
  else if ((adiw_st | sbiw_st) == SC_LOGIC_1)
    v_alu_data_r_in = "00000000";
  else
    v_alu_data_r_in = reg_rr_out.read();

  // ALU Rd INPUT
  alu_data_d_in = reg_rd_out.read();
  alu_data_r_in = v_alu_data_r_in;
}

//
// Set pa15_pm
//
// sensitive << rampz_out << idc_elpm
void pm_fetch_dec::set_pa15_pm()
{
  sc_lv<8> v_rampz_out = rampz_out;

  pa15_pm = v_rampz_out[0] & idc_elpm; // 0 WHEN LPM INSTRUCTIONS RAMPZ(0) WHEN ELPM INSTRUCTION
}

//
// set brbx and rxx offsets
//
// sensitive << dex_brxx_offset << dex_adr12mem_s
void pm_fetch_dec::set_offsets()
{
  sc_lv<7> v_dex_brxx_offset = dex_brxx_offset;
  sc_lv<12> v_dex_adr12mem_s = dex_adr12mem_s;

  // For outputs
  sc_lv<16> v_offset_brbx;
  sc_lv<16> v_offset_rxx;
  

  // OFFSET FOR BRBC/BRBS INSTRUCTIONS +63/-64
  if (v_dex_brxx_offset[6] == SC_LOGIC_0)
    v_offset_brbx = ("0000000000",v_dex_brxx_offset.range(5,0));
  else
    v_offset_brbx = ("1111111111",v_dex_brxx_offset.range(5,0));
  
  // OFFSET FOR RJMP/RCALL INSTRUCTIONS +2047/-2048
  if (v_dex_adr12mem_s[11] == SC_LOGIC_0)
    v_offset_rxx = ("00000",v_dex_adr12mem_s.range(10,0));
  else
    v_offset_rxx = ("11111",v_dex_adr12mem_s.range(10,0));

  offset_brbx = v_offset_brbx;
  offset_rxx = v_offset_rxx;
}

//
// Set program counter signals
//
// sensitive << offset_brbx << offset_rxx
// sensitive << pa15_pm << reg_z_out << irqackad_int << dbusin << program_counter
// sensitive << idc_brbc << idc_brbs << bit_test_op_out << idc_rjmp << idc_rcall
// sensitive << idc_lpm << idc_elpm << jmp_st1 << call_st1 << irq_st1 << ret_st1 << reti_st1 << ret_st2 | reti_st2 << lpm_st1
// sensitive << program_counter_tmp << idc_ld_x << idc_ld_y << idc_ld_z << idc_ldd_y << idc_ldd_z << idc_st_x << idc_st_y << idc_st_z << idc_std_y << idc_std_z << sts_st1 << lds_st1 << idc_adiw << idc_sbiw << idc_push << idc_pop << idc_cbi << idc_sbi << rcall_st1 << icall_st1 << call_st2 << irq_st2 << cpuwait << ret_st1 << reti_st1
void pm_fetch_dec::set_pc_signals()
{
  // For pre-calculations
  sc_uint<16> v_program_counter_in;
  sc_uint<16> v_program_counter = program_counter.read();

  sc_lv<16> v_offset_brbx = offset_brbx;
  sc_int<16> i_offset_brbx = v_offset_brbx;

  sc_lv<16> v_offset_rxx = offset_rxx;
  sc_int<16> i_offset_rxx = v_offset_rxx;

  sc_logic v_pa15_pm = pa15_pm;
  sc_lv<16> v_reg_z_out = reg_z_out;
  sc_lv<5> v_irqackad_int = irqackad_int;
  sc_lv<8> v_dbusin = dbusin;

  sc_lv<16> program_counter4lpm = (v_pa15_pm,v_reg_z_out.range(15,1));
  sc_lv<16> program_counter4irq = ("0000000000",v_irqackad_int,"0");
  sc_lv<16> program_counter4ret1 = (v_dbusin,"00000000");
  sc_lv<16> program_counter4ret2 = ("00000000",v_dbusin);

  // i_program_counter = v_program_counter;

  if (((idc_brbc | idc_brbs) & bit_test_op_out) == SC_LOGIC_1)
    v_program_counter_in = /*(sc_uint<16>)*/(v_program_counter + i_offset_brbx); // BRBC/BRBS
  else if ((idc_rjmp | idc_rcall) == SC_LOGIC_1)
    {
      v_program_counter_in = /*(sc_uint<16>)*/(v_program_counter + i_offset_rxx);  // RJMP/RCAL
      cout << "idc_rcall: " << v_program_counter_in << endl;
    }
  else if ((idc_ijmp | idc_icall) == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ reg_z_out;                           // IJMP/ICALL
  else if ((idc_lpm | idc_elpm) == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ (program_counter4lpm);
  else if ((jmp_st1 | call_st1) == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ instruction_reg;                     // LPM/ELPM
  else if (irq_st1 == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ program_counter4irq;                 // INTERRUPT
  else if (/*(ret_st1 | reti_st1)*/(ret_st2 | reti_st2) == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ program_counter4ret1;                // RET/RETI -> PC HIGH BYTE
  else if (/*(ret_st2 | reti_st2)*/(ret_st1 | reti_st1) == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ program_counter4ret2;                // RET/RETI -> PC LOW BYTE
  else if (lpm_st1 == SC_LOGIC_1)
    v_program_counter_in = /* (sc_uint<16>)*/ program_counter_tmp.read();          // AFTER LPM/ELPM INSTRUCTION
  else 
    v_program_counter_in = /* (sc_uint<16>)*/ (v_program_counter + 1);             // THE MOST USUAL CASE

  pc_low_en = ~(idc_ld_x | idc_ld_y | idc_ld_z | idc_ldd_y | idc_ldd_z |
		idc_st_x | idc_st_y | idc_st_z | idc_std_y | idc_std_z |
		sts_st1 | lds_st1 |
		idc_adiw | idc_sbiw |
		idc_push | idc_pop |
		idc_cbi | idc_sbi |
		rcall_st1 | icall_st1 | call_st2 | irq_st2 | cpuwait |
		/*ret_st1 | reti_st1 */ret_st2 | reti_st2);

  pc_high_en = ~(idc_ld_x | idc_ld_y | idc_ld_z | idc_ldd_y | idc_ldd_z |
		 idc_st_x | idc_st_y | idc_st_z | idc_std_y | idc_std_z |
		 sts_st1 | lds_st1 | 
		 idc_adiw | idc_sbiw |
		 idc_push | idc_pop |
		 idc_cbi | idc_sbi |
		 rcall_st1 | icall_st1 | call_st2 | irq_st2 | cpuwait |
		 /*ret_st2 | reti_st2 */ret_st1 | reti_st1);

  

  // Output
  program_counter_in = (sc_uint<16>)v_program_counter_in;
}

//
// Set program_counter
//
// sensitive << pc_high << pc_low
/*
void pm_fetch_dec::set_program_counter_signal()
{
  sc_uint<8> v_pc_high = pc_high.read();
  sc_uint<8> v_pc_low  = pc_low.read();

  sc_uint<16> v_program_counter;

  v_program_counter = (v_pc_high,v_pc_low);
  program_counter = v_program_counter;

  // cout << "pm_fetch_dec::set_program_counter_signal()" << endl;
  // cout << "pc_low  = " << pc_low.read() << endl;
  // cout << "pc_high = " << pc_high.read() << endl;
  // cout << "program_counter = " << v_program_counter << endl;
}
*/

//
// Set pc
//
// sensitive << program_counter
void pm_fetch_dec::set_pc_signal()
{
  cout << "pm_fetch_dec::set_pc_signal()" << endl;
  cout << "pc       = " << program_counter << endl;
  // cout << "pc (int) = " << (unsigned int)program_counter.read()<< endl;

  pc = program_counter;
}

//
// Set skip_inst_start
//
// sensitive << idc_sbrc << idc_sbrs << idc_sbic << idc_sbis << bit_test_op_out << idc_cpse << alu_z_flag_out
void pm_fetch_dec::set_skip_inst_start()
{
  skip_inst_start = ((idc_sbrc | idc_sbrs | idc_sbic | idc_sbis) & bit_test_op_out) |
    (idc_cpse & alu_z_flag_out);
}

//
// INTERRUPT LOGIC AND STATE MACHINE 
//
// sensitive << irqlines
void pm_fetch_dec::interrupt_logic()
{
  sc_lv<23> v_irqlines = irqlines;
  
  // For output
  sc_lv<16> v_irq_vector_adr;

  if (v_irqlines == "00000000000000000000000")
    irq_int = SC_LOGIC_0;
  else
    {
      irq_int = SC_LOGIC_1;
      cout << "pm_fetch_dec::interrupt_logic()" << endl;
      cout << "INTERRUPT detected!" << endl;
    }
 
  v_irq_vector_adr[15] = SC_LOGIC_0;
  v_irq_vector_adr[14] = SC_LOGIC_0;
  v_irq_vector_adr[13] = SC_LOGIC_0;
  v_irq_vector_adr[12] = SC_LOGIC_0;
  v_irq_vector_adr[11] = SC_LOGIC_0;
  v_irq_vector_adr[10] = SC_LOGIC_0;
  v_irq_vector_adr[9]  = SC_LOGIC_0;
  v_irq_vector_adr[8]  = SC_LOGIC_0;
  v_irq_vector_adr[7]  = SC_LOGIC_0;
  v_irq_vector_adr[6]  = SC_LOGIC_0;
  v_irq_vector_adr[0]  = SC_LOGIC_0;

  /*
  if      (v_irqlines[0] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00001";
  else if (v_irqlines[1] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00010";
  else if (v_irqlines[2] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00011";
  else if (v_irqlines[3] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00100";
  else if (v_irqlines[4] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00101";
  else if (v_irqlines[5] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00110";
  else if (v_irqlines[6] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00111";
  else if (v_irqlines[7] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01000";
  else if (v_irqlines[8] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01001";
  else if (v_irqlines[9] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01010";
  else if (v_irqlines[10] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01011";
  else if (v_irqlines[11] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01100";
  else if (v_irqlines[12] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01101";
  else if (v_irqlines[13] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01110";
  else if (v_irqlines[14] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01111"; // 0xF0
  else if (v_irqlines[15] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10000";
  else if (v_irqlines[16] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10001";
  else if (v_irqlines[17] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10010";
  else if (v_irqlines[18] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10011";
  else if (v_irqlines[19] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10100";
  else if (v_irqlines[20] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10101";
  else if (v_irqlines[21] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10110";
  else if (v_irqlines[22] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10111";
  else
    v_irq_vector_adr.range(5,1) = "00000";
  */
  if      (v_irqlines[1] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00001";
  else if (v_irqlines[2] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00010";
  else if (v_irqlines[3] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00011";
  else if (v_irqlines[4] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00100";
  else if (v_irqlines[5] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00101";
  else if (v_irqlines[6] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00110";
  else if (v_irqlines[7] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "00111";
  else if (v_irqlines[8] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01000";
  else if (v_irqlines[9] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01001";
  else if (v_irqlines[10] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01010";
  else if (v_irqlines[11] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01011";
  else if (v_irqlines[12] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01100";
  else if (v_irqlines[13] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01101";
  else if (v_irqlines[14] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01110";
  else if (v_irqlines[15] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "01111"; // 0xF0
  else if (v_irqlines[16] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10000";
  else if (v_irqlines[17] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10001";
  else if (v_irqlines[18] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10010";
  else if (v_irqlines[19] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10011";
  else if (v_irqlines[20] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10100";
  else if (v_irqlines[21] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10101";
  else if (v_irqlines[22] == SC_LOGIC_1)
    v_irq_vector_adr.range(5,1) = "10110";
  else
    v_irq_vector_adr.range(5,1) = "00000";

  // Output final values
  irq_vector_adr = v_irq_vector_adr;
}

//
// MULTI CYCLE INSTRUCTION FLAG FOR IRQ
//
// sensitive << sreg_bop_wr_en << sreg_adr_eq << dbusout_int << sreg_out << adr_int
// sensitive << irqack_int << irqackad_int
void pm_fetch_dec::irq_flags()
{
  sc_lv<8> v_sreg_bop_wr_en = sreg_bop_wr_en;
  sc_logic v_sreg_adr_eq = sreg_adr_eq;
  sc_lv<8> v_dbusout_int = dbusout_int;
  sc_lv<8> v_sreg_out = sreg_out;
  sc_lv<6> v_adr_int = adr_int;

  cpu_busy = idc_adiw | idc_sbiw | idc_cbi | idc_sbi |
    idc_rjmp | idc_ijmp |
    idc_jmp | jmp_st1 |
    idc_brbs | idc_brbc |
    idc_lpm | lpm_st1 |
    skip_inst_start | (skip_inst_st1 & two_word_inst) |
    idc_ld_x | idc_ld_y | idc_ldd_y | idc_ld_z | idc_ldd_z | (ld_st & cpuwait) |
    idc_st_x | idc_st_y | idc_std_y | idc_st_z | idc_std_z | (st_st & cpuwait) |
    idc_lds | lds_st1 | (lds_st2 & cpuwait) | 
    idc_sts | sts_st1 | (sts_st2 & cpuwait) |
    idc_rcall | rcall_st1 | (rcall_st2 & cpuwait) |          // RCALL
    idc_icall | icall_st1 | (icall_st2 & cpuwait) |	     // ICALL
    idc_call | call_st1 | call_st2 | (call_st3 & cpuwait) |  // CALL
    (idc_bclr & v_sreg_bop_wr_en[7]) |                       // ??? CLI
    (iowe_int & v_sreg_adr_eq & ~v_dbusout_int[7]) |         // ??? Writing '0' to I flag (OUT/STD/ST/STD)
    nirq_st0 |
    // idc_ret  | nret_st0 | // Old variant 
    idc_ret | ret_st1 | ret_st2 |
    // idc_reti | nreti_st0; // At least one instruction must be executed after RETI & before the new interrupt.
    idc_reti | reti_st1 | reti_st2;
			
  if (v_adr_int == SREG_Address)
    sreg_adr_eq = SC_LOGIC_1;
  else
    sreg_adr_eq = SC_LOGIC_0;

  irq_start = irq_int & (~cpu_busy.read()) & v_sreg_out[7];

  irqack = irqack_int;
  irqackad = irqackad_int;
}

//
// SREG FLAGS WRITE ENABLE LOGIC
//
// sensitive << dex_bitnum_sreg << reti_st3 << alu_h_flag_out << alu_s_flag_out
// sensitive << alu_v_flag_out << alu_n_flag_out << alu_z_flag_out << alu_c_flag_out
// sensitive << idc_add << idc_adc << idc_adiw << adiw_st << idc_sub  << idc_subi << idc_sbc << idc_sbci << idc_sbiw << sbiw_st << idc_cp << idc_cpc << idc_cpi << idc_and << idc_andi << idc_or << idc_ori << idc_eor << idc_com << idc_neg << idc_inc << idc_dec << idc_lsr << idc_ror << idc_asr
// sensitive << idc_bset << idc_bclr << idc_bst
void pm_fetch_dec::sreg_flags_en_logic()
{
  sc_lv<3>   v_dex_bitnum_sreg = dex_bitnum_sreg;
  sc_uint<3> i_dex_bitnum_sreg = v_dex_bitnum_sreg;

  sc_logic v_reti_st3 = reti_st3;
  sc_logic v_alu_h_flag_out = alu_h_flag_out;
  sc_logic v_alu_s_flag_out = alu_s_flag_out;
  sc_logic v_alu_v_flag_out = alu_v_flag_out;
  sc_logic v_alu_n_flag_out = alu_n_flag_out;
  sc_logic v_alu_z_flag_out = alu_z_flag_out;
  sc_logic v_alu_c_flag_out = alu_c_flag_out;

  // For outputs
  sc_lv<8> v_sreg_bop_wr_en;
  sc_lv<8> v_sreg_fl_wr_en;
  sc_lv<8> v_sreg_fl_in;

  v_sreg_bop_wr_en = "00000000";
  if ((idc_bclr | idc_bset) == SC_LOGIC_1)
    v_sreg_bop_wr_en[i_dex_bitnum_sreg] = SC_LOGIC_1;

  v_sreg_fl_wr_en[0] = idc_add | idc_adc | (idc_adiw | adiw_st) | idc_sub  | idc_subi | 
    idc_sbc | idc_sbci | (idc_sbiw | sbiw_st) | idc_com | idc_neg |
    idc_cp | idc_cpc | idc_cpi |
    idc_lsr | idc_ror | idc_asr | v_sreg_bop_wr_en[0];

  v_sreg_fl_wr_en[1] = idc_add | idc_adc | (idc_adiw | adiw_st) | idc_sub  | idc_subi | 
    idc_sbc | idc_sbci | (idc_sbiw | sbiw_st) | idc_cp | idc_cpc | idc_cpi |
    idc_and | idc_andi | idc_or | idc_ori | idc_eor | idc_com | idc_neg |
    idc_inc | idc_dec | idc_lsr | idc_ror | idc_asr | v_sreg_bop_wr_en[1];

  v_sreg_fl_wr_en[2] = idc_add | idc_adc | adiw_st | idc_sub  | idc_subi | 
    idc_sbc | idc_sbci | sbiw_st | idc_cp | idc_cpc | idc_cpi |
    idc_and | idc_andi | idc_or | idc_ori | idc_eor | idc_com | idc_neg |
    idc_inc | idc_dec | idc_lsr | idc_ror | idc_asr | v_sreg_bop_wr_en[2];

  v_sreg_fl_wr_en[3] = idc_add | idc_adc | idc_adiw | idc_sub  | idc_subi | 
    idc_sbc | idc_sbci | idc_sbiw | idc_neg | idc_inc | idc_dec |
    idc_cp | idc_cpc | idc_cpi |idc_lsr | idc_ror | idc_asr | v_sreg_bop_wr_en[3];

  v_sreg_fl_wr_en[4] = idc_add | idc_adc | adiw_st | idc_sub | idc_subi | 
    idc_sbc | idc_sbci | sbiw_st | idc_cp | idc_cpc | idc_cpi |
    idc_and | idc_andi | idc_or | idc_ori | idc_eor | idc_com | idc_neg |
    idc_inc | idc_dec | idc_lsr | idc_ror | idc_asr | v_sreg_bop_wr_en[4];

  v_sreg_fl_wr_en[5] = idc_add | idc_adc | idc_sub  | idc_subi |
    idc_cp | idc_cpc | idc_cpi | idc_sbc | idc_sbci | idc_neg | v_sreg_bop_wr_en[5];

  v_sreg_fl_wr_en[6] = idc_bst | v_sreg_bop_wr_en[6];

  v_sreg_fl_wr_en[7] = irq_st1 | reti_st3 | v_sreg_bop_wr_en[7]; // WAS "irq_start"

  if ((idc_bst | idc_bclr | idc_bset) == SC_LOGIC_1)
    {
      v_sreg_fl_in = bit_pr_sreg_out.read();
      /*
      cout << "pm_fetch_dec::sreg_flags_en_logic()" << endl;
      cout << "bit_pr_sreg_out = " << bit_pr_sreg_out.read() << endl;
      */
    }
  else
    {
      v_sreg_fl_in[7] = v_reti_st3;
      v_sreg_fl_in[6] = SC_LOGIC_0;
      v_sreg_fl_in[5] = v_alu_h_flag_out;
      v_sreg_fl_in[4] = v_alu_s_flag_out;
      v_sreg_fl_in[3] = v_alu_v_flag_out;
      v_sreg_fl_in[2] = v_alu_n_flag_out;
      v_sreg_fl_in[1] = v_alu_z_flag_out;
      v_sreg_fl_in[0] = v_alu_c_flag_out;
    }

  sreg_bop_wr_en = v_sreg_bop_wr_en;
  sreg_fl_wr_en = v_sreg_fl_wr_en;
  sreg_fl_in = v_sreg_fl_in;
}

//
// Output everthing!!
// Set all internal signals to outputs
//
// sensitive << EVERYTHING!
void pm_fetch_dec::output_everything()
{
  sc_lv<3> v_reg_h_adr;

  // FOR ALU 
  idc_add_out   = idc_add;
  idc_adc_out   = idc_adc;
  idc_adiw_out  = idc_adiw;
  idc_sub_out   = idc_sub;
  idc_subi_out  = idc_subi;
  idc_sbc_out   = idc_sbc;
  idc_sbci_out  = idc_sbci;
  idc_sbiw_out  = idc_sbiw;
  adiw_st_out   = adiw_st;
  sbiw_st_out   = sbiw_st;
  idc_and_out   = idc_and;
  idc_andi_out  = idc_andi;
  idc_or_out    = idc_or;
  idc_ori_out   = idc_ori;
  idc_eor_out   = idc_eor;              
  idc_com_out   = idc_com;              
  idc_neg_out   = idc_neg;
  idc_inc_out   = idc_inc;
  idc_dec_out   = idc_dec;
  idc_cp_out    = idc_cp;              
  idc_cpc_out   = idc_cpc;
  idc_cpi_out   = idc_cpi;
  idc_cpse_out  = idc_cpse;                            
  idc_lsr_out   = idc_lsr;
  idc_ror_out   = idc_ror;
  idc_asr_out   = idc_asr;
  idc_swap_out  = idc_swap;

  // FOR THE BIT PROCESSOR
  idc_sbi_out  = idc_sbi;
  sbi_st_out   = sbi_st;
  idc_cbi_out  = idc_cbi;
  cbi_st_out   = cbi_st;
  idc_bld_out  = idc_bld;
  idc_bst_out  = idc_bst;
  idc_bset_out = idc_bset;
  idc_bclr_out = idc_bclr;
  idc_sbic_out = idc_sbic;
  idc_sbis_out = idc_sbis;
  idc_sbrs_out = idc_sbrs;
  idc_sbrc_out = idc_sbrc;
  idc_brbs_out = idc_brbs;
  idc_brbc_out = idc_brbc;
  idc_reti_out = idc_reti;
  
  // 16 bit write address to regfile
  reg_h_wr = (idc_st_x | idc_st_y | idc_st_z | idc_ld_x | idc_ld_y | idc_ld_z) & (idc_psinc | idc_prdec);

  v_reg_h_adr[0] = idc_st_x | idc_ld_x;
  v_reg_h_adr[1] = idc_st_y | idc_std_y | idc_ld_y | idc_ldd_y;
  v_reg_h_adr[2] = idc_st_z | idc_std_z | idc_ld_z | idc_ldd_z;

  // STACK POINTER CONTROL
  sp_ndown_up = /*idc_pop*/pop_st | idc_ret | (ret_st1 & ~cpuwait.read()) | idc_reti | (reti_st1 & ~cpuwait.read());
  sp_en = /*idc_push | idc_pop*/pop_st | push_st | idc_rcall | (rcall_st1 & ~cpuwait.read()) | idc_icall | 
    (icall_st1 & ~cpuwait.read()) | idc_ret | (ret_st1 & ~cpuwait.read()) | idc_reti | 
    (reti_st1 & ~cpuwait.read()) | call_st1 | (call_st2 & ~cpuwait.read()) | irq_st1 | 
    (irq_st2 & ~cpuwait.read());

  branch = dex_condition;
  sreg_bit_num = dex_bitnum_sreg;
  if ((cbi_st | sbi_st) == SC_LOGIC_1)
    bit_num_r_io = cbi_sbi_bit_num_tmp;
  else
    bit_num_r_io = dex_bitop_bitnum;

  sleepi = idc_sleep;

  // Output temp signals
  reg_h_adr = v_reg_h_adr;
}
