//
// $Id: pport.h,v 1.2 2003/06/10 10:42:06 nj Exp $
//
#ifndef _PPORT_H
#define _PPORT_H
#include <systemc.h>
#include "config.h"

#include "avrucpackage.h"

// Should be moved to avrucpackage?
#define PORTX_Adr "000000"
#define DDRX_Adr "000000"
#define PINX_Adr "000000"

SC_MODULE(pport)
{
  sc_in<bool> cp2;
  sc_in<bool> ireset;

  sc_in<sc_lv<6> > adr;
  sc_in<sc_lv<8> > dbus_in;
  sc_out<sc_lv<8> > dbus_out;
  sc_in<sc_logic> iore;
  sc_in<sc_logic> iowe;
  sc_out<sc_logic> out_en;
  sc_out<sc_lv<8> > portx;
  sc_out<sc_lv<8> > ddrx;
  sc_in<sc_lv<8> > pinx;

  sc_signal<sc_lv<8> > portx_int;
  sc_signal<sc_lv<8> > ddrx_int;
  sc_signal<sc_lv<8> > pinx_resync;
  sc_signal<sc_lv<8> > pinx_inreg;
  sc_signal<sc_logic> portx_sel;
  sc_signal<sc_logic> ddrx_sel;
  sc_signal<sc_logic> pinx_sel;

  void portx_dff();
  void ddrx_dff();
  void pinxsynchronizer();
  void pinxinputreg();
  void out_en_set();
  void output_set();

  SC_CTOR(pport)
  {
    SC_METHOD(portx_dff);
    sensitive_pos << cp2;

    SC_METHOD(ddrx_dff);
    sensitive_pos << cp2;

    SC_METHOD(pinxsynchronizer);
    sensitive_pos << cp2;

    SC_METHOD(pinxinputreg);
    sensitive_pos << cp2;

    SC_METHOD(out_en_set);
    sensitive << adr << portx_sel << ddrx_sel << pinx_sel;

    SC_METHOD(output_set);
    sensitive << portx_int << ddrx_int;
  }
};

#endif
