//
// $Id: reg_file.cc,v 1.13 2003/10/07 15:43:57 nj Exp $
//

#include "reg_file.h"

//
// Write registers...
// 
// sensitive_pos << clk
void reg_file::register_write()
{
  // sc_lv<32> v_register_wr_en = register_wr_en;
  sc_uint<5> i = reg_rd_adr.read();

  if (!nrst)
    {
      register_file[0] = "00000000";
      register_file[1] = "00000000";
      register_file[2] = "00000000";
      register_file[3] = "00000000";
      register_file[4] = "00000000";
      register_file[5] = "00000000";
      register_file[6] = "00000000";
      register_file[7] = "00000000";
      register_file[8] = "00000000";
      register_file[9] = "00000000";
      register_file[10] = "00000000";
      register_file[11] = "00000000";
      register_file[12] = "00000000";
      register_file[13] = "00000000";
      register_file[14] = "00000000";
      register_file[15] = "00000000";
      register_file[16] = "00000000";
      register_file[17] = "00000000";
      register_file[18] = "00000000";
      register_file[19] = "00000000";
      register_file[20] = "00000000";
      register_file[21] = "00000000";
      register_file[22] = "00000000";
      register_file[23] = "00000000";
      register_file[24] = "00000000";
      register_file[25] = "00000000";
    }
    else
    {
      if (regwe.read() == SC_LOGIC_1)
	{
	  register_file[regadr.read()] = reg_out.read();
	}
      else
	{
	  if ((reg_rd_wr.read() == 1) && 
	      (i != 26) && (i != 27) && 
	      (i != 28) && (i != 29) && 
	      (i != 30) && (i != 31))
	    register_file[i] = reg_rd_in;
	  
#if !defined(SYNTHESIS) && defined(PRINTREGFILE)
	  sc_lv<16> lx = (r27h.read(),r26h.read());
	  sc_uint<16> x = lx;
	  sc_lv<16> ly = (r29h.read(),r28h.read());
	  sc_uint<16> y = ly;
	  sc_lv<16> lz = (r31h.read(),r30h.read());
	  sc_uint<16> z = lz;
	  cout << "reg_file::register_write()" << endl;
	  cout << "register_file[00] = " << register_file[0] << endl;
	  cout << "register_file[01] = " << register_file[1] << endl;
	  cout << "register_file[02] = " << register_file[2] << endl;
	  cout << "register_file[03] = " << register_file[3] << endl;
	  for (int i = 16; i <= 25; i++)
	    cout << "register_file[" << i << "] = " << register_file[i] << endl;
	  cout << "register X = " << r27h << r26h << " (" << x << ")" << endl;
	  cout << "register Y = " << r29h << r28h << " (" << y << ")" << endl;
	  cout << "register Z = " << r31h << r30h << " (" << z << ")" << endl;
#endif
	}
    }
}

//
// 
//
// sensitive_pos << clk
void reg_file::r26to31()
{
  sc_logic v_reg_rd_wr = reg_rd_wr.read();
  sc_uint<5> i = reg_rd_adr.read();

  sc_lv<3> v_reg_h_adr = reg_h_adr;
  sc_lv<16> v_reg_h_in = reg_h_in;

  if (!nrst)
    {
      r26h = "00000000";
      r27h = "00000000";
      r28h = "00000000";
      r29h = "00000000";
      r30h = "00000000";
      r31h = "00000000";
    }
  else
    {
      if ((i == 26) && (v_reg_rd_wr == 1))
	r26h = reg_rd_in;
      else if ((v_reg_h_adr[0] == 1) && (reg_h_wr == 1))
	r26h = v_reg_h_in.range(7,0);
      if ((i == 27) && (v_reg_rd_wr == 1))
	r27h = reg_rd_in;
      else if ((v_reg_h_adr[0] == 1) && (reg_h_wr == 1))
	r27h = v_reg_h_in.range(15,8);
	  
      if ((i == 28) && (v_reg_rd_wr == 1))
	r28h = reg_rd_in;
      else if ((v_reg_h_adr[1] == 1) && (reg_h_wr == 1))
	r28h = v_reg_h_in.range(7,0);
      if ((i == 29) && (v_reg_rd_wr == 1))
	r29h = reg_rd_in;
      else if ((v_reg_h_adr[1] == 1) && (reg_h_wr == 1))
	r29h = v_reg_h_in.range(15,8);
	  
      if ((i == 30) && (v_reg_rd_wr == 1))
	r30h = reg_rd_in;
      else if ((v_reg_h_adr[2] == 1) && (reg_h_wr == 1))
	r30h = v_reg_h_in.range(7,0);
      if ((i == 31) && (v_reg_rd_wr == 1))
	r31h = reg_rd_in;
      else if ((v_reg_h_adr[2] == 1) && (reg_h_wr == 1))
	r31h = v_reg_h_in.range(15,8);
    }
}

//
// Output register z
//
// sensitive << r31h << r30h
void reg_file::regz_output()
{
  sc_lv<8> v_r31h = r31h;
  sc_lv<8> v_r30h = r30h;

  reg_z_out = (v_r31h,v_r30h);
}

//
// Output reg_rd_out and set mux
//
// sensitive << register_file[0-26]
// sensitive << reg_rd_adr << reg_rr_adr
// sensitive << r26h << r27h << r28h << r29h << r30h << r31h
// sensitive << regre << regadr
void reg_file::output_regs()
{
  sc_uint<5> i = reg_rd_adr.read();
  sc_uint<5> j = reg_rr_adr.read();

  if (i == 31)
    reg_rd_out = r31h;
  else if (i == 30)
    reg_rd_out = r30h;
  else if (i == 29)
    reg_rd_out = r29h;
  else if (i == 28)
    reg_rd_out = r28h;
  else if (i == 27)
    reg_rd_out = r27h;
  else if (i == 26)
    reg_rd_out = r26h;
  else
    reg_rd_out = register_file[i];

  if (j == 31)
    reg_rr_out = r31h;
  else if (j == 30)
    reg_rr_out = r30h;
  else if (j == 29)
    reg_rr_out = r29h;
  else if (j == 28)
    reg_rr_out = r28h;
  else if (j == 27)
    reg_rr_out = r27h;
  else if (j == 26)
    reg_rr_out = r26h;
  else
    reg_rr_out = register_file[j];

  if (regre.read() == SC_LOGIC_1)
    reg_in = register_file[regadr.read()];

}

//
// Set sg_tmp_h_data signal
//
// sensitive << r26h << r27h << r28h << r29h << r30h << r31h << reg_h_adr << sg_tmp_h_data;
void reg_file::h_dat_mux()
{
  sc_lv<3> v_reg_h_adr = reg_h_adr;
  sc_lv<8> v_r26h = r26h;
  sc_lv<8> v_r27h = r27h;
  sc_lv<8> v_r28h = r28h;
  sc_lv<8> v_r29h = r29h;
  sc_lv<8> v_r30h = r30h;
  sc_lv<8> v_r31h = r31h;

  // For output
  sc_lv<16> v_sg_tmp_h_data = sg_tmp_h_data.read();

  if (v_reg_h_adr[0] == 1)
    {
      v_sg_tmp_h_data[0] = v_r26h[0];
      v_sg_tmp_h_data[1] = v_r26h[1];
      v_sg_tmp_h_data[2] = v_r26h[2];
      v_sg_tmp_h_data[3] = v_r26h[3];
      v_sg_tmp_h_data[4] = v_r26h[4];
      v_sg_tmp_h_data[5] = v_r26h[5];
      v_sg_tmp_h_data[6] = v_r26h[6];
      v_sg_tmp_h_data[7] = v_r26h[7];

      v_sg_tmp_h_data[8]  = v_r27h[0];
      v_sg_tmp_h_data[9]  = v_r27h[1];
      v_sg_tmp_h_data[10] = v_r27h[2];
      v_sg_tmp_h_data[11] = v_r27h[3];
      v_sg_tmp_h_data[12] = v_r27h[4];
      v_sg_tmp_h_data[13] = v_r27h[5];
      v_sg_tmp_h_data[14] = v_r27h[6];
      v_sg_tmp_h_data[15] = v_r27h[7];
    }
  else if (v_reg_h_adr[1] == 1)
    {
      v_sg_tmp_h_data[0] = v_r28h[0];
      v_sg_tmp_h_data[1] = v_r28h[1];
      v_sg_tmp_h_data[2] = v_r28h[2];
      v_sg_tmp_h_data[3] = v_r28h[3];
      v_sg_tmp_h_data[4] = v_r28h[4];
      v_sg_tmp_h_data[5] = v_r28h[5];
      v_sg_tmp_h_data[6] = v_r28h[6];
      v_sg_tmp_h_data[7] = v_r28h[7];

      v_sg_tmp_h_data[8]  = v_r29h[0];
      v_sg_tmp_h_data[9]  = v_r29h[1];
      v_sg_tmp_h_data[10] = v_r29h[2];
      v_sg_tmp_h_data[11] = v_r29h[3];
      v_sg_tmp_h_data[12] = v_r29h[4];
      v_sg_tmp_h_data[13] = v_r29h[5];
      v_sg_tmp_h_data[14] = v_r29h[6];
      v_sg_tmp_h_data[15] = v_r29h[7];
    }
  else if (v_reg_h_adr[2] == 1)
    {
      v_sg_tmp_h_data[0] = v_r30h[0];
      v_sg_tmp_h_data[1] = v_r30h[1];
      v_sg_tmp_h_data[2] = v_r30h[2];
      v_sg_tmp_h_data[3] = v_r30h[3];
      v_sg_tmp_h_data[4] = v_r30h[4];
      v_sg_tmp_h_data[5] = v_r30h[5];
      v_sg_tmp_h_data[6] = v_r30h[6];
      v_sg_tmp_h_data[7] = v_r30h[7];

      v_sg_tmp_h_data[8]  = v_r31h[0];
      v_sg_tmp_h_data[9]  = v_r31h[1];
      v_sg_tmp_h_data[10] = v_r31h[2];
      v_sg_tmp_h_data[11] = v_r31h[3];
      v_sg_tmp_h_data[12] = v_r31h[4];
      v_sg_tmp_h_data[13] = v_r31h[5];
      v_sg_tmp_h_data[14] = v_r31h[6];
      v_sg_tmp_h_data[15] = v_r31h[7];
    }

  sg_tmp_h_data = v_sg_tmp_h_data;
}

//
// Output data to address bus
//
// sensitive << sg_tmp_h_data << post_inc << pre_dec << sg_adr16_predec;
void reg_file::addr_bus_output()
{
  sc_lv<16>   v_sg_tmp_h_data = sg_tmp_h_data;
  sc_uint<16> i_sg_tmp_h_data = v_sg_tmp_h_data;

  sg_adr16_postinc = i_sg_tmp_h_data + 1;
  sg_adr16_predec  = i_sg_tmp_h_data - 1;

  if (pre_dec == 1)
    reg_h_out = sg_adr16_predec;
  else
    reg_h_out = sg_tmp_h_data;

  if (post_inc == 1)
    reg_h_in = sg_adr16_postinc;
  else
    reg_h_in = sg_adr16_predec;
}

