//
// $Id: simple_timer.cc,v 1.3 2003/07/14 09:42:23 nj Exp $
//
#include "simple_timer.h"

//
// The main counter - increment on rising clock edge
//
void simple_timer::main_counter()
{
  sc_lv<8> v_counter = counter;
  sc_uint<8> i_counter = v_counter;

  if (!ireset)
    {
      i_counter = 0;
    }
  else
    {
      i_counter = i_counter + 1;
    }

  counter = v_counter = i_counter;
}

//
// Output timer irq
//
// sensitive_pos << cp2
void simple_timer::irq_out()
{
  if (!ireset)
    {
      irqline_int = SC_LOGIC_0;
    }
  else
    {
      irqline_int = (~irqline_int.read() & count_end.read()) | (irqline_int.read() & ~timer_irqack.read());
    }
}

//
// Output signals
//
// sensitive << counter << irqline_int
void simple_timer::set_signals()
{
  sc_lv<8> v_counter = counter;
  sc_logic v_irqline_int = irqline_int;

  if (v_counter == "11111111")
    {
      count_end = SC_LOGIC_1;
    }
  else
    {
      count_end = SC_LOGIC_0;
    }

  irqline = ~v_irqline_int;
}

