//
// $Id: simple_timer.h,v 1.4 2003/07/16 10:40:00 nj Exp $
//
#ifndef _SIMPLE_TIMER_H
#define _SIMPLE_TIMER_H
#include <systemc.h>
#include "config.h"
#include "constants.h"

SC_MODULE(simple_timer)
{
  sc_in<bool> cp2;
  sc_in<bool> ireset;

  sc_out<sc_logic> irqline;
  sc_in<sc_logic> timer_irqack;

  sc_signal<sc_lv<8> > counter;
  sc_signal<sc_logic> irqline_int;
  sc_signal<sc_logic> count_end;

  void main_counter();
  void irq_out();
  void set_signals();

  SC_CTOR(simple_timer)
  {

    SC_METHOD(main_counter);
    sensitive_pos << cp2;

    SC_METHOD(irq_out);
    sensitive_pos << cp2;

    SC_METHOD(set_signals);
    sensitive << counter << irqline_int;

  }
};

#endif
